#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

char *Buffer = NULL;
int mlBufferSize = MAX_TINE_BUFFER;
#define usageStr "tine_devices usage:\n ret=tine_devices('/<context>/<server>'[,'<property>']);\n'ret' contains the status/error message and returned names"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray  *data[PROPMAX];
  const char *field[PROPMAX];
  double *lp, dt = (double)time(NULL);
  int  error[PROPMAX];
  char *name, *prp=NULL,*typestr, *mxerrStr=NULL;
  char *p;
  char buf[1024];
  char bf1[1024], *c=NULL, *c1=NULL, *c2=NULL, *c3=NULL;
  char dtstr[32];
  char prop[80];
  char dev[80];
  int  len,type,size,fmtsiz,readsize = -1,ln,datatype = -1;
  mwSize dims[2];
  int  i,j,k,err,count = 0,n,startindex = 3;
  int  lim,nmb;
  int acc = CA_READ;
  mxChar *CharData;
  char tsstr[64];
  char *tmpBuffer;
  NAME64 *dlist;
  int ndevs;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 2: // timer interval (int)
      if (!mxIsChar(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[1]) + 1;
      prp = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[1],prp,len);
    case 1: // target
      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      // the requested data endpoint ...
      len = mxGetN(prhs[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],name,len);
      break;
    default:
      mxerr(usageStr);
  }   
  if (Buffer == NULL)
  {
    if ((Buffer=(char *)malloc(MAX_TINE_BUFFER)) == NULL)
    {
      plhs[0] = mxCreateString("Out of memory !!!");
      return;
    }
    mlBufferSize = MAX_TINE_BUFFER;
  }

  dlist = (NAME64 *)Buffer;
  ndevs = MAX_TINE_BUFFER/64;
  err = GetSystemDevices(name,prp,dlist,&ndevs);
  if (err != 0)
  {
    field[0] = (char *)mxCalloc(6, sizeof(char));
    strcpy((char *)field[0],"error");
    GetLastLinkError(-err,Buffer);
    memset(buf,0,1024);
    plhs[0] = mxCreateStructMatrix(1, 1, 1, &field[0]);
    sprintf(buf,"Names read error: %.32s",Buffer);
    data[0] = mxCreateString(buf);
    mxSetFieldByNumber(plhs[0], 0, 0, data[0]);
  }
  else
  {
    size = ndevs;
    for (n=0; n<ndevs; n++)
    {
      field[n] = (char *)mxCalloc(72, sizeof(char));
      data[n] = mxCreateString(dlist[n].name);
      sprintf((char *)field[n],"device %d",n);
      //strncpy((char *)field[n],dlist[n].name,64);
    }
    plhs[0] = mxCreateStructMatrix(1,1,ndevs,&field[0]);
    for (n=0; n<ndevs; n++)
    {
      mxSetFieldByNumber(plhs[0],0,n,data[n]);
    }

 	}
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
  mxFree(name);
}
