#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

#define setDblVal(i,n,b,f,v) {\
  for (i=0; i<(n); i++) {\
    if ((f) == CF_BYTE) (b)[i] = (BYTE)((v)[i]);\
    else if ((f) == CF_INT16) ((short *)(b))[i] = (short)((v)[i]);\
    else if ((f) == CF_INT32) ((int *)(b))[i] = (int)((v)[i]);\
    else if ((f) == CF_INT64) ((SINT64 *)(b))[i] = (SINT64)((v)[i]);\
    else if ((f) == CF_FLOAT) ((float *)(b))[i] = (float)((v)[i]);\
    else ((double *)(b))[i] = ((v)[i]);\
  }\
}

#define setDbltVal(n,b,f,v) {\
	for (i=0; i<(n); i++) {\
    if ((f) == CF_INTINT) {\
      ((INTINT *)(b))[i].i1val = (int)((v)[i*2]);\
      ((INTINT *)(b))[i].i2val = (int)((v)[i*2+1]);\
    }\
    else if ((f) == CF_FLTINT) {\
      ((FLTINT *)(b))[i].fval = (float)((v)[i*2]);\
      ((FLTINT *)(b))[i].ival = (int)((v)[i*2+1]);\
    }\
    else if ((f) == CF_FLTFLT) {\
      ((FLTFLT *)(b))[i].f1val = (float)((v)[i*2]);\
      ((FLTFLT *)(b))[i].f2val = (float)((v)[i*2+1]);\
    }\
    else if ((f) == CF_DBLDBL) {\
      ((DBLDBL *)(b))[i].d1val = ((v)[i*2]);\
      ((DBLDBL *)(b))[i].d2val = ((v)[i*2+1]);\
    }\
  }\
}

#define setTpltVal(n,b,f,v) {\
	for (i=0; i<(n); i++) {\
    if ((f) == CF_INTINTINT) {\
      ((INTINTINT *)(b))[i].i1val = (int)((v)[i*3]);\
      ((INTINTINT *)(b))[i].i2val = (int)((v)[i*3+1]);\
      ((INTINTINT *)(b))[i].i3val = (int)((v)[i*3+2]);\
    }\
    else if ((f) == CF_FLTINTINT) {\
      ((FLTINTINT *)(b))[i].fval = (float)((v)[i*3]);\
      ((FLTINTINT *)(b))[i].i1val = (int)((v)[i*3+1]);\
      ((FLTINTINT *)(b))[i].i2val = (int)((v)[i*3+2]);\
    }\
    else if ((f) == CF_INTFLTINT) {\
      ((INTFLTINT *)(b))[i].i1val = (int)((v)[i*3]);\
      ((INTFLTINT *)(b))[i].fval = (float)((v)[i*3+1]);\
      ((INTFLTINT *)(b))[i].i2val = (int)((v)[i*3+2]);\
    }\
    else if ((f) == CF_FLTFLTINT) {\
      ((FLTFLTINT *)(b))[i].f1val = (float)((v)[i*3]);\
      ((FLTFLTINT *)(b))[i].f2val = (float)((v)[i*3+1]);\
      ((FLTFLTINT *)(b))[i].ival = (int)((v)[i*3+2]);\
    }\
    else if ((f) == CF_DBLDBLDBL) {\
      ((DBLDBLDBL *)(b))[i].d1val = ((v)[i*3]);\
      ((DBLDBLDBL *)(b))[i].d2val = ((v)[i*3+1]);\
      ((DBLDBLDBL *)(b))[i].d3val = ((v)[i*3+2]);\
    }\
  }\
}

#define setQuadVal(n,b,f,v) {\
	for (i=0; i<(n); i++) {\
    if ((f) == CF_INTINTINTINT) {\
      ((DADDRESS *)(b))[i].i1val = (int)((v)[i*4]);\
      ((DADDRESS *)(b))[i].i2val = (int)((v)[i*4+1]);\
      ((DADDRESS *)(b))[i].i3val = (int)((v)[i*4+2]);\
      ((DADDRESS *)(b))[i].i4val = (int)((v)[i*4+3]);\
    }\
    else if ((f) == CF_INTFLTFLTFLT) {\
      ((DFILTER *)(b))[i].ival = (int)((v)[i*4]);\
      ((DFILTER *)(b))[i].f1val = (float)((v)[i*4+1]);\
      ((DFILTER *)(b))[i].f2val = (float)((v)[i*4+2]);\
      ((DFILTER *)(b))[i].f3val = (float)((v)[i*4+3]);\
    }\
    else if ((f) == CF_INTINTFLTFLT) {\
      ((FWINDOW *)(b))[i].i1val = (int)((v)[i*4]);\
      ((FWINDOW *)(b))[i].i2val = (int)((v)[i*4+1]);\
      ((FWINDOW *)(b))[i].f1val = (float)((v)[i*4+2]);\
      ((FWINDOW *)(b))[i].f2val = (float)((v)[i*4+3]);\
    }\
    else if ((f) == CF_TTII) {\
      ((DWINDOW *)(b))[i].t1 = (int)((v)[i*4]);\
      ((DWINDOW *)(b))[i].t2 = (int)((v)[i*4+1]);\
      ((DWINDOW *)(b))[i].i1val = (int)((v)[i*4+2]);\
      ((DWINDOW *)(b))[i].i2val = (int)((v)[i*4+3]);\
    }\
    else if ((f) == CF_FLTINTFLTINT) {\
      ((FLTINTFLTINT *)(b))[i].f1val = (float)((v)[i*4]);\
      ((FLTINTFLTINT *)(b))[i].i1val = (int)((v)[i*4+1]);\
      ((FLTINTFLTINT *)(b))[i].f2val = (float)((v)[i*4+2]);\
      ((FLTINTFLTINT *)(b))[i].i2val = (int)((v)[i*4+3]);\
    }\
  }\
}

char Buffer[MAX_TINE_BUFFER];
#define usageStr "tine_pushdata usage:\n ret=tine_pushdata('<property>','<device>',data[,size,isScheduled,timestamp,systemstamp,userstamp])"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray	*data[PROPMAX];
  mxChar *mxc;
  mxArray *sa;
  const char *field[PROPMAX];
  char prp[PROPERTY_NAME_SIZE], dev[DEVICE_NAME_SIZE], *mxerrStr=NULL;
  double *lp;
  double ts = 0;
  char c,*p,buf[128],stsbuf[64],fmtOut[64],dtag[32];
  int	i,k,siz=0,len,rlen,fmt,fmtsiz,err,n,nf;
  int sizout=1;
  int isScheduled=FALSE;
  int sysstamp=0, usrstamp=0;
  const char *fld;
  struct structStruct *ss;
  struct structFormat *sf;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 8:
      if (!mxIsDouble(prhs[7])) mxerr(usageStr);
      if (mxGetM(prhs[7]) != 1) mxerr(usageStr);
      usrstamp = (int)mxGetScalar(prhs[7]);
    case 7:
      if (!mxIsDouble(prhs[6])) mxerr(usageStr);
      if (mxGetM(prhs[6]) != 1) mxerr(usageStr);
      sysstamp = (int)mxGetScalar(prhs[6]);
    case 6:
      if (!mxIsDouble(prhs[5])) mxerr(usageStr);
      if (mxGetM(prhs[5]) != 1) mxerr(usageStr);
      ts = mxGetScalar(prhs[5]);
    case 5: // scheduled flag
      if (!mxIsDouble(prhs[4])) mxerr(usageStr);
      if (mxGetM(prhs[4]) != 1) mxerr(usageStr);
      isScheduled = (int)mxGetScalar(prhs[4]);
    case 4: // device list capacity
      if (!mxIsDouble(prhs[3])) mxerr(usageStr);
      if (mxGetM(prhs[3]) != 1) mxerr(usageStr);
      siz = (int)mxGetScalar(prhs[3]);
    case 3: 
      if (!mxIsChar(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[1]) + 1;
      //dev = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[1],dev,len);

      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[0]) + 1;
      //prp = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],prp,len);

      err = GetRegisteredPropertyInformation(NULL,prp,NULL,NULL,NULL,
              &sizout,NULL,fmtOut,NULL,NULL);
      if (err != 0) goto inpt_err;
      dtag[0] = 0;
      if ((rlen=mxGetM(prhs[2])) == 1)
      {
        len = mxGetN(prhs[2]);
      }
      else if (mxGetN(prhs[2]) == 1)
      {
        len = rlen;
      }
      else 
        mxerr(usageStr);
      if (siz == 0 || siz > len) siz = len;
      if ((p=strchr(fmtOut,'.')) != NULL)
      {
        *p++ = 0;
        strncpy(dtag,p,TAG_NAME_SIZE);
      }
      fmt = GetFormatFromString(fmtOut);
      fmtsiz = GetFormatSize(fmt);
      if(mxIsChar(prhs[2]))
      { // a string type
        switch (fmt)
        {
          case CF_TEXT: 
            mxGetString(prhs[2],Buffer,len);
            if (siz == 0 || siz > len) siz = len;
            break;
          case CF_NAME8:
          case CF_NAME16:
          case CF_NAME32:
          case CF_NAME48:
          case CF_NAME64:
            if (siz > 1)
            {
              const int *dims = mxGetDimensions(prhs[2]);
              for (i=0; i<siz; i++)
              {
                mxc = mxGetChars(prhs[2]);
                for (i=0; i<siz; i++)
                { /* string arrays transposed in MatLab ? */
                  memset(&buf[fmtsiz*i],0,fmtsiz);
                  for (k=0; k<fmtsiz && k<dims[1]; k++) 
                  {
                    c = (char)mxc[siz*k+i];
                    Buffer[fmtsiz*i+k] = c;
                    if (c == 0) break;
                  }
                }
              }
            }
            else
            {
              if (len > fmtsiz) len = fmtsiz;
			        mxGetString(prhs[2],Buffer,len);
            }
            break;
          default:
            err = illegal_format; 
            goto inpt_err; 
        }
      }
      if (mxIsDouble(prhs[2]))
      { // a number type
			  lp = (double *)mxGetPr(prhs[2]);
        switch (fmt)
        {
          case CF_BYTE:
          case CF_INT16:
          case CF_INT32:
          case CF_INT64:
          case CF_FLOAT:
          case CF_DOUBLE:
            setDblVal(i,siz,Buffer,fmt,lp)
            break;
		      case CF_INTINT:
		      case CF_FLTINT:
		      case CF_FLTFLT:
		      case CF_DBLDBL:
            siz /= 2;
            setDbltVal(siz,Buffer,fmt,lp);
            break;
          case CF_INTINTINT:
          case CF_FLTINTINT:
          case CF_INTFLTINT:
          case CF_FLTFLTINT:
          case CF_DBLDBLDBL:
            siz /= 3;
            setTpltVal(siz,Buffer,fmt,lp);
            break;
		      case CF_IFFF:
		      case CF_IIFF:
		      case CF_IIII:
		      case CF_TTII:
		      case CF_FIFI:
            siz /= 4;
            setQuadVal(siz,Buffer,fmt,lp);
            break;		
          default:
            err = illegal_format; 
            goto inpt_err; 
        }
      }
      if (mxIsStruct(prhs[2]))
      { // a struct type
        if (fmt != CF_STRUCT)
        {
          err = illegal_format; 
          goto inpt_err; 
        }
        if ((ss=GetStructFromTag(dtag)) != NULL && siz > 0)
        {
          fmtsiz = GetStructSize(dtag);
          for (k=0, sf=ss->s; sf != NULL && k < 256; k++, sf=sf->nxt) if (sf->fmt == CF_NULL) k--;
          nf = k; // number of fields (n.b. legacy registrations might have a 'CF_NULL' in termination)s
          if (nf != mxGetNumberOfFields(prhs[2])) mxerr("wrong number of fields");
          for (i=0; i<siz; i++)
          {
            for (n=nf-1, sf=ss->s; sf != NULL && n >=0; n--, sf=sf->nxt)
            { 
              fld = mxGetFieldNameByNumber(prhs[2],n);
              sa = mxGetField(prhs[2],i,fld);
              switch (sf->fmt)
              {
                case CF_INT16:
                case CF_INT32:
                case CF_FLOAT:
                case CF_DOUBLE:
           			  if(!mxIsDouble(sa)) mxerr("wrong field type");
			            lp = (double *)mxGetPr(sa);
                  setDblVal(k,sf->siz,&Buffer[fmtsiz*i+sf->off],sf->fmt,lp);
                  break;
                case CF_TEXT:
           			  if(!mxIsChar(sa)) mxerr("wrong field type");
                  len = mxGetN(sa);
                  mxGetString(sa,(char *)&Buffer[fmtsiz*i+sf->off],len+1);
                  break;
                case CF_NULL:
                  n++; 
                  continue;
              }
            }
          }
        }
      }
      break;
    default:
      mxerr(usageStr);
  }   

  err = pushBufferedDataEx(prp,dev,(BYTE *)Buffer,siz,isScheduled,ts,sysstamp,usrstamp);
inpt_err:
  if (err != 0)
  {
    GetLastLinkError(err,stsbuf);
    sprintf(buf,"tine_pushdata : <%d> %.64s",err,stsbuf);
    mexErrMsgTxt(buf);
  }
  data[0] = mxCreateDoubleMatrix(1,1,mxREAL);
  lp = (double *)mxGetPr(data[0]);
  *lp = (double)err;
  plhs[0] = data[0];
  
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }

}
