#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <ctime>
#include <cmath>

//#include 	<unistd.h>
#include <sys/types.h>

#include 	<setjmp.h>
extern "C" {
#include    "cdjpeg.h"
#include    "cderror.h"
}
#include "tine.h"
#include "tbufsrv.h"

#include 	<mex.h>
#include <matrix.h>
#ifndef VOID
	#define		VOID			void
#endif

#ifndef VOIDP
	typedef		void *VOIDP;
#endif
/*
#ifndef INT32
	typedef		int				INT32;
#endif
*/
#ifndef UINT32
	typedef		unsigned int	UINT32;
#endif

#ifndef DOUBLE
	typedef		double			DOUBLE;
#endif

#ifndef CHAR
	typedef		char			CHAR;
#endif

#ifndef UCHAR
	typedef		unsigned char	UCHAR; 
#endif

#ifndef UINT16
	typedef		unsigned short	UINT16;
#endif

#ifndef INT16
	typedef		signed short	INT16;
#endif

#ifndef socktype
	typedef		int				socktype;
#endif


#define Bytef	Byte 
#define uLongf	uLong 

#define		FCN_NONE			      0
#define		FCN_AVERAGE			   1
#define		FCN_ENVELOPE		   2 
#define		FCN_SIGNIFICANCE	   3 

#define		TYPE_NONE_EMPTY     -1
#define		TYPE_CHOOSE			   0
#define		TYPE_IMM			      1
#define		TYPE_IMC			      2 
#define		TYPE_BKG			      3
#define		TYPE_BKC			      4
#define		TYPE_SIGNIFICANCE	   5


//#define MAX_FDSETS 64 // taken from Phil, project.def, LINUX
const INT32 platformMaxFdSets = MAX_FDSETS;

#ifdef UNIX
	typedef		unsigned int	DWORD;
#endif
typedef struct
{
	UINT32	time;            // time since Jan 1st, 1970 in seconds
	UINT16	millitm; // milliseconds which have to be added to time_t
	INT16		timezone;         // is not used in this program
	INT16		dstflag;          // is not used in this program
	CHAR		reserved[2];
} swtimeb; 

#define		REAL_SIZE_TIMEB		12

typedef struct 
{
	UINT32	kennung;        // 0x11223344;
	UINT32	compression;    // FOURCC codec name
	UINT32	len_total;      // length of data + formatheader + vidhdr
	UINT32	len_data;       // length of the data (compressed image) 
	UINT32	len_fmthdr;     // length of the format header (needed for decompression on windows side)
	UINT32	frameno;        /* since starting the grabbing on the grabserver 
						    (note: each camera change results in restarting grabbing) */
	
	swtimeb	timestamp;      // _timeb structure
	UINT32	cameraport;     // port of the camera (0..3)
	UINT32	widthframe;     // width of the frame
	UINT32	heightframe;    // height of the frame
	UINT32	compressed;     /* 1= picture is compressed
							    0= picture is not compressed because if it would be compressed 
								it would be too big                                            */
	CHAR	reserved[12]; 

	DOUBLE	scale;
	UINT32	bpp;
	UINT32  bpp_effective;	    // willbe used as bits per pixel effective (12bpp e.g.)
	
	CHAR	reserved1[8];
} VIDHDR;

#define		REAL_SIZE_VIDHDR	88

struct VIDINFHDR
{
	UINT32	  width;
	UINT32	  height;
	UINT32	  bpp;
	UINT32     bpp_effective;

	DOUBLE	  scale;

	INT32	     numframes;

	INT32	     type; // TYPE_

	VOID     **framebits;
	DOUBLE    *framescales;
};

const unsigned int  CF_IMAGE_FORMAT_BASETAG = 0x33565356; 

//! image format: grayscale data (single plane)
const int CF_IMAGE_FORMAT_GRAY		= 0;
//! image format: rgb data (three planes interwoven as 24 bits)
const int CF_IMAGE_FORMAT_RGB			= 1;
//! image format: rgb data (three planes plus alpha interwoven as 32 bits)
const int CF_IMAGE_FORMAT_RGBA		= 2;
//! image format: rgb data (three planes interwoven as 15 bits)
const int CF_IMAGE_FORMAT_RGB15		= 3;
//! image format: rgb data (three planes interwoven as 16 bits; green=6)
const int CF_IMAGE_FORMAT_RGB16		= 4;
//! image format: jpeg data bits follow
const int CF_IMAGE_FORMAT_JPEG		= 5;
//! image format: tiff data bits follow
const int CF_IMAGE_FORMAT_TIFF		= 6;
//! image format: YUV411 encoded raw bits 
const int CF_IMAGE_FORMAT_YUV411		= 7;
//! image format: YUV422 encoded raw bits 
const int CF_IMAGE_FORMAT_YUV422		= 8;
//! image format: YUV444 encoded raw bits 
const int CF_IMAGE_FORMAT_YUV444		= 9;
//! image format: HUFFYUV-compressed image bits follow
const int CF_IMAGE_FORMAT_HUFFYUV		= 10;
//! image format: Windows BMP (BitMaP) bits follow
const int CF_IMAGE_FORMAT_BMP			= 11;
//! image format: Bayer-packed image bits 
const int CF_IMAGE_FORMAT_BAYER		= 12;

const int CF_IMAGE_FORMAT_MAX		= CF_IMAGE_FORMAT_BAYER;

char *ReturnFormatString(int aImageFormat)
{
	if (aImageFormat == CF_IMAGE_FORMAT_GRAY)
		return "CF_IMAGE_FORMAT_GRAY";
	else if (aImageFormat == CF_IMAGE_FORMAT_RGB)
		return "CF_IMAGE_FORMAT_RGB";
	else if (aImageFormat == CF_IMAGE_FORMAT_RGBA)
		return "CF_IMAGE_FORMAT_RGBA";
	else if (aImageFormat == CF_IMAGE_FORMAT_RGB15)
		return "CF_IMAGE_FORMAT_RGB15";
	else if (aImageFormat == CF_IMAGE_FORMAT_RGB16)
		return "CF_IMAGE_FORMAT_RGB16";
	else if (aImageFormat == CF_IMAGE_FORMAT_JPEG)
		return "CF_IMAGE_FORMAT_JPEG";
	else if (aImageFormat == CF_IMAGE_FORMAT_TIFF)
		return "CF_IMAGE_FORMAT_TIFF";
	else if (aImageFormat == CF_IMAGE_FORMAT_YUV411)
		return "CF_IMAGE_FORMAT_YUV411";
	else if (aImageFormat == CF_IMAGE_FORMAT_YUV422)
		return "CF_IMAGE_FORMAT_YUV422";
	else if (aImageFormat == CF_IMAGE_FORMAT_YUV444)
		return "CF_IMAGE_FORMAT_YUV444";
	else if (aImageFormat == CF_IMAGE_FORMAT_HUFFYUV)
		return "CF_IMAGE_FORMAT_HUFFYUV";
	else if (aImageFormat == CF_IMAGE_FORMAT_BMP)
		return "CF_IMAGE_FORMAT_BMP";
	else if (aImageFormat == CF_IMAGE_FORMAT_BAYER)
		return "CF_IMAGE_FORMAT_BAYER";

	else return "UNKNOWN!";
}

struct huffman_entry { UCHAR shift, add; };

const struct huffman_entry luma[256] = {
  {2,3}, {4,9}, {3,5}, {5,12}, {5,10}, {7,35}, {7,32}, {7,29}, {7,27}, {8,50}, {8,48}, {8,45}, {8,44}, {8,41}, {8,39}, {8,37}, 
  {9,73}, {9,70}, {9,68}, {9,65}, {9,64}, {9,61}, {9,58}, {9,56}, {9,53}, {9,50}, {9,49}, {9,46}, {9,44}, {9,41}, {9,38}, {9,36}, 
  {10,68}, {10,65}, {10,63}, {10,61}, {10,58}, {10,55}, {10,53}, {10,51}, {10,48}, {10,46}, {10,45}, {10,43}, {10,41}, {10,39}, {10,38}, {10,36}, 
  {10,35}, {10,33}, {10,32}, {10,30}, {10,29}, {10,27}, {10,26}, {10,25}, {11,48}, {11,47}, {11,46}, {11,44}, {11,43}, {11,41}, {11,40}, {11,39}, 
  {11,37}, {11,36}, {11,35}, {11,34}, {11,32}, {11,31}, {11,30}, {11,28}, {11,27}, {11,26}, {11,24}, {11,23}, {11,22}, {11,20}, {11,19}, {12,37}, 
  {12,35}, {12,34}, {12,33}, {12,31}, {12,30}, {12,29}, {12,27}, {12,26}, {12,24}, {12,23}, {12,21}, {12,20}, {12,18}, {12,17}, {12,15}, {13,29}, 
  {13,27}, {13,26}, {13,24}, {13,22}, {13,21}, {13,19}, {13,17}, {13,16}, {13,14}, {14,26}, {14,25}, {14,23}, {14,21}, {14,19}, {14,18}, {14,16}, 
  {14,15}, {15,27}, {15,25}, {15,23}, {15,21}, {15,19}, {15,17}, {15,16}, {15,14}, {16,26}, {16,25}, {16,23}, {16,21}, {16,18}, {16,17}, {16,14}, 
  {16,12}, {17,17}, {17,19}, {17,13}, {17,4}, {17,9}, {17,2}, {17,11}, {17,1}, {17,7}, {17,8}, {17,0}, {17,16}, {17,3}, {17,14}, {17,6}, 
  {17,12}, {17,10}, {17,5}, {17,15}, {17,18}, {16,11}, {16,10}, {16,13}, {16,15}, {16,16}, {16,19}, {16,20}, {16,22}, {16,24}, {16,27}, {15,15}, 
  {15,18}, {15,20}, {15,22}, {15,24}, {15,26}, {14,14}, {14,17}, {14,20}, {14,22}, {14,24}, {14,27}, {13,15}, {13,18}, {13,20}, {13,23}, {13,25}, 
  {13,28}, {12,16}, {12,19}, {12,22}, {12,25}, {12,28}, {12,32}, {12,36}, {11,21}, {11,25}, {11,29}, {11,33}, {11,38}, {11,42}, {11,45}, {11,49}, 
  {10,28}, {10,31}, {10,34}, {10,37}, {10,40}, {10,42}, {10,44}, {10,47}, {10,49}, {10,50}, {10,52}, {10,54}, {10,56}, {10,57}, {10,59}, {10,60}, 
  {10,62}, {10,64}, {10,66}, {10,67}, {10,69}, {9,35}, {9,37}, {9,39}, {9,40}, {9,42}, {9,43}, {9,45}, {9,47}, {9,48}, {9,51}, {9,52}, 
  {9,54}, {9,55}, {9,57}, {9,59}, {9,60}, {9,62}, {9,63}, {9,66}, {9,67}, {9,69}, {9,71}, {9,72}, {8,38}, {8,40}, {8,42}, {8,43}, 
  {8,46}, {8,47}, {8,49}, {8,51}, {7,26}, {7,28}, {7,30}, {7,31}, {7,33}, {7,34}, {6,18}, {6,19}, {5,11}, {5,13}, {4,7}, {4,8}
};


const struct huffman_entry decode_luma9[512] = {
 { 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},
 { 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},
 { 0,  0},{ 0,  0},{ 0,  0},{ 9,213},{ 9, 31},{ 9,214},{ 9, 30},{ 9,215},{ 9,216},{ 9, 29},{ 9,217},{ 9,218},{ 9, 28},{ 9,219},{ 9, 27},{ 9,220},
 { 9,221},{ 9, 26},{ 9, 25},{ 9,222},{ 9,223},{ 9, 24},{ 9,224},{ 9,225},{ 9, 23},{ 9,226},{ 9, 22},{ 9,227},{ 9,228},{ 9, 21},{ 9,229},{ 9,230},
 { 9, 20},{ 9, 19},{ 9,231},{ 9,232},{ 9, 18},{ 9,233},{ 9, 17},{ 9,234},{ 9,235},{ 9, 16},{ 8, 15},{ 8, 15},{ 8,236},{ 8,236},{ 8, 14},{ 8, 14},
 { 8,237},{ 8,237},{ 8, 13},{ 8, 13},{ 8,238},{ 8,238},{ 8,239},{ 8,239},{ 8, 12},{ 8, 12},{ 8, 11},{ 8, 11},{ 8,240},{ 8,240},{ 8,241},{ 8,241},
 { 8, 10},{ 8, 10},{ 8,242},{ 8,242},{ 8,  9},{ 8,  9},{ 8,243},{ 8,243},{ 7,244},{ 7,244},{ 7,244},{ 7,244},{ 7,  8},{ 7,  8},{ 7,  8},{ 7,  8},
 { 7,245},{ 7,245},{ 7,245},{ 7,245},{ 7,  7},{ 7,  7},{ 7,  7},{ 7,  7},{ 7,246},{ 7,246},{ 7,246},{ 7,246},{ 7,247},{ 7,247},{ 7,247},{ 7,247},
 { 7,  6},{ 7,  6},{ 7,  6},{ 7,  6},{ 7,248},{ 7,248},{ 7,248},{ 7,248},{ 7,249},{ 7,249},{ 7,249},{ 7,249},{ 7,  5},{ 7,  5},{ 7,  5},{ 7,  5},
 { 6,250},{ 6,250},{ 6,250},{ 6,250},{ 6,250},{ 6,250},{ 6,250},{ 6,250},{ 6,251},{ 6,251},{ 6,251},{ 6,251},{ 6,251},{ 6,251},{ 6,251},{ 6,251},
 { 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},{ 5,  4},
 { 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},{ 5,252},
 { 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},{ 5,  3},
 { 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},{ 5,253},
 { 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},
 { 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},{ 4,254},
 { 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},
 { 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},{ 4,255},
 { 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},
 { 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},{ 4,  1},
 { 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},
 { 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},
 { 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},
 { 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},{ 3,  2},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
 { 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},{ 2,  0},
};


const struct huffman_entry decode_luma12[512] = {
 { 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{ 0,  0},{12, 94},
 {12,177},{12, 93},{12, 92},{12,178},{12, 91},{12, 90},{12,179},{12, 89},{12, 88},{12,180},{12, 87},{12, 86},{12,181},{12, 85},{12, 84},{12, 83},
 {12,182},{12, 82},{12, 81},{12, 80},{12,183},{12, 79},{11, 78},{11, 78},{11, 77},{11, 77},{11,184},{11,184},{11, 76},{11, 76},{11, 75},{11, 75},
 {11, 74},{11, 74},{11,185},{11,185},{11, 73},{11, 73},{11, 72},{11, 72},{11, 71},{11, 71},{11,186},{11,186},{11, 70},{11, 70},{11, 69},{11, 69},
 {11, 68},{11, 68},{11,187},{11,187},{11, 67},{11, 67},{11, 66},{11, 66},{11, 65},{11, 65},{11, 64},{11, 64},{11,188},{11,188},{11, 63},{11, 63},
 {11, 62},{11, 62},{11, 61},{11, 61},{11,189},{11,189},{11, 60},{11, 60},{11, 59},{11, 59},{11,190},{11,190},{11, 58},{11, 58},{11, 57},{11, 57},
 {11, 56},{11, 56},{11,191},{11,191},{10, 55},{10, 55},{10, 55},{10, 55},{10, 54},{10, 54},{10, 54},{10, 54},{10, 53},{10, 53},{10, 53},{10, 53},
 {10,192},{10,192},{10,192},{10,192},{10, 52},{10, 52},{10, 52},{10, 52},{10, 51},{10, 51},{10, 51},{10, 51},{10,193},{10,193},{10,193},{10,193},
 {10, 50},{10, 50},{10, 50},{10, 50},{10, 49},{10, 49},{10, 49},{10, 49},{10,194},{10,194},{10,194},{10,194},{10, 48},{10, 48},{10, 48},{10, 48},
 {10, 47},{10, 47},{10, 47},{10, 47},{10,195},{10,195},{10,195},{10,195},{10, 46},{10, 46},{10, 46},{10, 46},{10, 45},{10, 45},{10, 45},{10, 45},
 {10,196},{10,196},{10,196},{10,196},{10, 44},{10, 44},{10, 44},{10, 44},{10,197},{10,197},{10,197},{10,197},{10, 43},{10, 43},{10, 43},{10, 43},
 {10,198},{10,198},{10,198},{10,198},{10, 42},{10, 42},{10, 42},{10, 42},{10, 41},{10, 41},{10, 41},{10, 41},{10,199},{10,199},{10,199},{10,199},
 {10, 40},{10, 40},{10, 40},{10, 40},{10,200},{10,200},{10,200},{10,200},{10,201},{10,201},{10,201},{10,201},{10, 39},{10, 39},{10, 39},{10, 39},
 {10,202},{10,202},{10,202},{10,202},{10, 38},{10, 38},{10, 38},{10, 38},{10,203},{10,203},{10,203},{10,203},{10, 37},{10, 37},{10, 37},{10, 37},
 {10,204},{10,204},{10,204},{10,204},{10,205},{10,205},{10,205},{10,205},{10, 36},{10, 36},{10, 36},{10, 36},{10,206},{10,206},{10,206},{10,206},
 {10,207},{10,207},{10,207},{10,207},{10, 35},{10, 35},{10, 35},{10, 35},{10,208},{10,208},{10,208},{10,208},{10, 34},{10, 34},{10, 34},{10, 34},
 {10,209},{10,209},{10,209},{10,209},{10, 33},{10, 33},{10, 33},{10, 33},{10,210},{10,210},{10,210},{10,210},{10,211},{10,211},{10,211},{10,211},
 {10, 32},{10, 32},{10, 32},{10, 32},{10,212},{10,212},{10,212},{10,212},{ 9,213},{ 9,213},{ 9,213},{ 9,213},{ 9,213},{ 9,213},{ 9,213},{ 9,213},
 { 9, 31},{ 9, 31},{ 9, 31},{ 9, 31},{ 9, 31},{ 9, 31},{ 9, 31},{ 9, 31},{ 9,214},{ 9,214},{ 9,214},{ 9,214},{ 9,214},{ 9,214},{ 9,214},{ 9,214},
 { 9, 30},{ 9, 30},{ 9, 30},{ 9, 30},{ 9, 30},{ 9, 30},{ 9, 30},{ 9, 30},{ 9,215},{ 9,215},{ 9,215},{ 9,215},{ 9,215},{ 9,215},{ 9,215},{ 9,215},
 { 9,216},{ 9,216},{ 9,216},{ 9,216},{ 9,216},{ 9,216},{ 9,216},{ 9,216},{ 9, 29},{ 9, 29},{ 9, 29},{ 9, 29},{ 9, 29},{ 9, 29},{ 9, 29},{ 9, 29},
 { 9,217},{ 9,217},{ 9,217},{ 9,217},{ 9,217},{ 9,217},{ 9,217},{ 9,217},{ 9,218},{ 9,218},{ 9,218},{ 9,218},{ 9,218},{ 9,218},{ 9,218},{ 9,218},
 { 9, 28},{ 9, 28},{ 9, 28},{ 9, 28},{ 9, 28},{ 9, 28},{ 9, 28},{ 9, 28},{ 9,219},{ 9,219},{ 9,219},{ 9,219},{ 9,219},{ 9,219},{ 9,219},{ 9,219},
 { 9, 27},{ 9, 27},{ 9, 27},{ 9, 27},{ 9, 27},{ 9, 27},{ 9, 27},{ 9, 27},{ 9,220},{ 9,220},{ 9,220},{ 9,220},{ 9,220},{ 9,220},{ 9,220},{ 9,220},
 { 9,221},{ 9,221},{ 9,221},{ 9,221},{ 9,221},{ 9,221},{ 9,221},{ 9,221},{ 9, 26},{ 9, 26},{ 9, 26},{ 9, 26},{ 9, 26},{ 9, 26},{ 9, 26},{ 9, 26},
 { 9, 25},{ 9, 25},{ 9, 25},{ 9, 25},{ 9, 25},{ 9, 25},{ 9, 25},{ 9, 25},{ 9,222},{ 9,222},{ 9,222},{ 9,222},{ 9,222},{ 9,222},{ 9,222},{ 9,222},
 { 9,223},{ 9,223},{ 9,223},{ 9,223},{ 9,223},{ 9,223},{ 9,223},{ 9,223},{ 9, 24},{ 9, 24},{ 9, 24},{ 9, 24},{ 9, 24},{ 9, 24},{ 9, 24},{ 9, 24},
 { 9,224},{ 9,224},{ 9,224},{ 9,224},{ 9,224},{ 9,224},{ 9,224},{ 9,224},{ 9,225},{ 9,225},{ 9,225},{ 9,225},{ 9,225},{ 9,225},{ 9,225},{ 9,225},
 { 9, 23},{ 9, 23},{ 9, 23},{ 9, 23},{ 9, 23},{ 9, 23},{ 9, 23},{ 9, 23},{ 9,226},{ 9,226},{ 9,226},{ 9,226},{ 9,226},{ 9,226},{ 9,226},{ 9,226},
 { 9, 22},{ 9, 22},{ 9, 22},{ 9, 22},{ 9, 22},{ 9, 22},{ 9, 22},{ 9, 22},{ 9,227},{ 9,227},{ 9,227},{ 9,227},{ 9,227},{ 9,227},{ 9,227},{ 9,227},
 { 9,228},{ 9,228},{ 9,228},{ 9,228},{ 9,228},{ 9,228},{ 9,228},{ 9,228},{ 9, 21},{ 9, 21},{ 9, 21},{ 9, 21},{ 9, 21},{ 9, 21},{ 9, 21},{ 9, 21},
 { 9,229},{ 9,229},{ 9,229},{ 9,229},{ 9,229},{ 9,229},{ 9,229},{ 9,229},{ 9,230},{ 9,230},{ 9,230},{ 9,230},{ 9,230},{ 9,230},{ 9,230},{ 9,230},
};

const struct huffman_entry decode_luma17[512] = {
 {17,139},{17,136},{17,134},{17,141},{17,132},{17,146},{17,143},{17,137},{17,138},{17,133},{17,145},{17,135},{17,144},{17,131},{17,142},{17,147},
 {17,140},{17,129},{17,148},{17,130},{16,150},{16,150},{16,149},{16,149},{16,128},{16,128},{16,151},{16,151},{16,127},{16,127},{16,152},{16,152},
 {16,153},{16,153},{16,126},{16,126},{16,125},{16,125},{16,154},{16,154},{16,155},{16,155},{16,124},{16,124},{16,156},{16,156},{16,123},{16,123},
 {16,157},{16,157},{16,122},{16,122},{16,121},{16,121},{16,158},{16,158},{15,120},{15,120},{15,120},{15,120},{15,159},{15,159},{15,159},{15,159},
 {15,119},{15,119},{15,119},{15,119},{15,118},{15,118},{15,118},{15,118},{15,160},{15,160},{15,160},{15,160},{15,117},{15,117},{15,117},{15,117},
 {15,161},{15,161},{15,161},{15,161},{15,116},{15,116},{15,116},{15,116},{15,162},{15,162},{15,162},{15,162},{15,115},{15,115},{15,115},{15,115},
 {15,163},{15,163},{15,163},{15,163},{15,114},{15,114},{15,114},{15,114},{15,164},{15,164},{15,164},{15,164},{15,113},{15,113},{15,113},{15,113},
 {14,165},{14,165},{14,165},{14,165},{14,165},{14,165},{14,165},{14,165},{14,112},{14,112},{14,112},{14,112},{14,112},{14,112},{14,112},{14,112},
 {14,111},{14,111},{14,111},{14,111},{14,111},{14,111},{14,111},{14,111},{14,166},{14,166},{14,166},{14,166},{14,166},{14,166},{14,166},{14,166},
 {14,110},{14,110},{14,110},{14,110},{14,110},{14,110},{14,110},{14,110},{14,109},{14,109},{14,109},{14,109},{14,109},{14,109},{14,109},{14,109},
 {14,167},{14,167},{14,167},{14,167},{14,167},{14,167},{14,167},{14,167},{14,108},{14,108},{14,108},{14,108},{14,108},{14,108},{14,108},{14,108},
 {14,168},{14,168},{14,168},{14,168},{14,168},{14,168},{14,168},{14,168},{14,107},{14,107},{14,107},{14,107},{14,107},{14,107},{14,107},{14,107},
 {14,169},{14,169},{14,169},{14,169},{14,169},{14,169},{14,169},{14,169},{14,106},{14,106},{14,106},{14,106},{14,106},{14,106},{14,106},{14,106},
 {14,105},{14,105},{14,105},{14,105},{14,105},{14,105},{14,105},{14,105},{14,170},{14,170},{14,170},{14,170},{14,170},{14,170},{14,170},{14,170},
 {13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},{13,104},
 {13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},{13,171},
 {13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},{13,103},
 {13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},{13,102},
 {13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},{13,172},
 {13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},{13,101},
 {13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},{13,173},
 {13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},{13,100},
 {13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},{13, 99},
 {13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},{13,174},
 {13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},{13, 98},
 {13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},{13,175},
 {13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},{13, 97},
 {13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},{13, 96},
 {13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},{13,176},
 {13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},{13, 95},
 {12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},
 {12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},{12, 94},
};
/* Huffman tables end */

// core decompression: Little Endian platforms 
UCHAR UnhuffLuma_Little_Endian(const UINT32* in, UINT32 *pos)
{
  UINT32 word = *pos >> 5;
  UINT32  bit = *pos & 31;
  UINT32  val = in[word];

  if (bit)    // the conditional is necessary because shifting by 32 doesn't work correctly on x86 processors
    val = (val << bit) | (in[word+1] >> (32-bit));
  // figure out the appropriate lookup table based on the number of leading zeros
  if (val >= (35 << 23)) {
    *pos += decode_luma9[val >> 23].shift;
    return decode_luma9[val >> 23].add;
  }
  if (val >= (15 << 20)) {
    *pos += decode_luma12[val >> 20].shift;
    return decode_luma12[val >> 20].add;
  }
  *pos += decode_luma17[val >> 15].shift;
  return decode_luma17[val >> 15].add;
}


VOID decompress_huffyuv( VOIDP uncompressed, const VOIDP compressed, UINT32 size_uncompressed)
{
  const UINT32* const in = (UINT32*) compressed;
  
  UCHAR* const end = (UCHAR *) uncompressed + size_uncompressed;
  UCHAR* out = (UCHAR *)uncompressed;
  UINT32 pos = 32;

  *(DWORD*)out = in[0] >> 8;

   
  out += 3;
  while (out < end) // decompression loop
  {
    out[0] = out[-3] + UnhuffLuma_Little_Endian(in, &pos);
    ++out;
  }
}


INT32 translate_charstream_into_vidhdr( VIDHDR *vidH, const UCHAR *stream)
{
	vidH->kennung = *((UINT32 *) stream);
	stream+=4;
	vidH->compression = *((UINT32 *) stream);
	stream+=4;
	vidH->len_total = *((UINT32 *) stream);
	stream+=4;
	vidH->len_data = *((UINT32 *) stream);
	stream+=4;
	vidH->len_fmthdr = *((UINT32 *) stream);
	
	stream+=4;
	vidH->frameno = *((UINT32 *) stream);
	stream+=4;
	vidH->timestamp.time = *((UINT32 *) stream);
	stream+=4;
	vidH->timestamp.millitm = *((UINT16 *) stream);
	stream+=2;
	vidH->timestamp.timezone = *((INT16 *) stream);
	stream+=2;
	vidH->timestamp.dstflag = *((INT16 *) stream);
	stream+=2;
	vidH->timestamp.reserved[0] = *((CHAR *) stream);
	stream+=1;
	vidH->timestamp.reserved[1] = *((CHAR *) stream);
	stream+=1;
	vidH->cameraport = *((UINT32 *) stream);
	stream+=4;
	vidH->widthframe = *((UINT32 *) stream);
	stream+=4;
	vidH->heightframe = *((UINT32 *) stream);
	stream+=4;
	vidH->compressed = *((UINT32 *) stream);
	stream+=4;
	memcpy(&vidH->reserved, stream, 12);
	stream+=12;
	
	vidH->scale = *((DOUBLE *) stream);
	stream+=8;
	vidH->bpp = *((UINT32 *) stream);
	stream+=4;
	vidH->bpp_effective = *((UINT32 *) stream);
	stream+=4;

	memcpy(&vidH->reserved1, stream, 8);
	
	//stream+=12;

	
	if (vidH->kennung != 0x11223344) return( -1 );

	if ((vidH->bpp != 8) && (vidH->bpp != 16) && (vidH->bpp != 32)) return( -1 );
		
	return 0;
}


void initialize_vidinfhdr( struct VIDINFHDR *vinf )
{
	vinf->type        = TYPE_NONE_EMPTY;
	vinf->framebits   = NULL;
	vinf->framescales = NULL;
}

//???????????????????????????????????????????????????????????????


typedef struct {
  struct jpeg_source_mgr pub;	/* public fields */

  FILE * infile;		/* source stream */
  JOCTET * buffer;		/* start of buffer */
  boolean start_of_file;	/* have we gotten any data yet? */
} my_source_mgr;

typedef my_source_mgr * my_src_ptr;

#define INPUT_BUF_SIZE  4096	/* choose an efficiently fread'able size */

/*
 * Initialize source --- called by jpeg_read_header
 * before any data is actually read.
 */

METHODDEF(void)
init_source (j_decompress_ptr cinfo)
{
  my_src_ptr src = (my_src_ptr) cinfo->src;

  /* We reset the empty-input-file flag for each image,
   * but we don't clear the input buffer.
   * This is correct behavior for reading a series of images from one source.
   */
  src->start_of_file = TRUE;
}

METHODDEF(boolean)
fill_input_buffer (j_decompress_ptr cinfo)
{
  my_src_ptr src = (my_src_ptr) cinfo->src;
  size_t nbytes;

  nbytes = JFREAD(src->infile, src->buffer, INPUT_BUF_SIZE);

  if (nbytes <= 0) {
    if (src->start_of_file)	/* Treat empty input file as fatal error */
      ERREXIT(cinfo, JERR_INPUT_EMPTY);
    WARNMS(cinfo, JWRN_JPEG_EOF);
    /* Insert a fake EOI marker */
    src->buffer[0] = (JOCTET) 0xFF;
    src->buffer[1] = (JOCTET) JPEG_EOI;
    nbytes = 2;
  }

  src->pub.next_input_byte = src->buffer;
  src->pub.bytes_in_buffer = nbytes;
  src->start_of_file = FALSE;

  return TRUE;
}

/*
 * Skip data --- used to skip over a potentially large amount of
 * uninteresting data (such as an APPn marker).
 *
 * Writers of suspendable-input applications must note that skip_input_data
 * is not granted the right to give a suspension return.  If the skip extends
 * beyond the data currently in the buffer, the buffer can be marked empty so
 * that the next read will cause a fill_input_buffer call that can suspend.
 * Arranging for additional bytes to be discarded before reloading the input
 * buffer is the application writer's problem.
 */

METHODDEF(void)
skip_input_data (j_decompress_ptr cinfo, long num_bytes)
{
  my_src_ptr src = (my_src_ptr) cinfo->src;

  /* Just a dumb implementation for now.  Could use fseek() except
   * it doesn't work on pipes.  Not clear that being smart is worth
   * any trouble anyway --- large skips are infrequent.
   */
  if (num_bytes > 0) {
    while (num_bytes > (long) src->pub.bytes_in_buffer) {
      num_bytes -= (long) src->pub.bytes_in_buffer;
      (void) fill_input_buffer(cinfo);
      /* note we assume that fill_input_buffer will never return FALSE,
       * so suspension need not be handled.
       */
    }
    src->pub.next_input_byte += (size_t) num_bytes;
    src->pub.bytes_in_buffer -= (size_t) num_bytes;
  }
}


/*
 * An additional method that can be provided by data source modules is the
 * resync_to_restart method for error recovery in the presence of RST markers.
 * For the moment, this source module just uses the default resync method
 * provided by the JPEG library.  That method assumes that no backtracking
 * is possible.
 */


/*
 * Terminate source --- called by jpeg_finish_decompress
 * after all data has been read.  Often a no-op.
 *
 * NB: *not* called by jpeg_abort or jpeg_destroy; surrounding
 * application must deal with any cleanup that should happen even
 * for error exit.
 */

METHODDEF(void)
term_source (j_decompress_ptr cinfo)
{
  /* no work necessary here */
}


// SW! copy and paste from jdatasrc.c END

/*METHODDEF(boolean)
fill_input_buffer_dummy (j_decompress_ptr cinfo)
{
  return TRUE;
}*/

GLOBAL(void) jpeg_mem_src (j_decompress_ptr cinfo, unsigned char *jpegbits, unsigned int len)
{
  my_src_ptr src;

  /* The source object and input buffer are made permanent so that a series
   * of JPEG images can be read from the same file by calling jpeg_stdio_src
   * only before the first one.  (If we discarded the buffer at the end of
   * one image, we'd likely lose the start of the next one.)
   * This makes it unsafe to use this manager and a different source
   * manager serially with the same JPEG object.  Caveat programmer.
   */
  
  if (cinfo->src == NULL) {	/* first time for this JPEG object? */
    cinfo->src = (struct jpeg_source_mgr *)
      (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
				  sizeof(my_source_mgr));
    src = (my_src_ptr) cinfo->src;

	src->buffer = (JOCTET *) jpegbits;
    src->pub.bytes_in_buffer = len; 
	src->pub.next_input_byte = src->buffer;

  }

  src = (my_src_ptr) cinfo->src;
  src->pub.init_source = init_source;
  src->pub.fill_input_buffer = fill_input_buffer;
  src->pub.skip_input_data = skip_input_data;
  src->pub.term_source = term_source;
  src->pub.resync_to_restart = jpeg_resync_to_restart; /* use default method */
}


typedef struct {
  struct jpeg_destination_mgr pub;		// public fields

  const unsigned char* jpeg_buffer;		// target stream 
  unsigned int jpeg_buffer_length_used; // length of buffer used
  unsigned int jpeg_buffer_size;		// size (maximum length usable) of buffer;
  int jpeg_buffer_offset;				// current "write position" in jpeg buffer // was called "ptr" before
  
  JOCTET * buffer;						// start of buffer

} sw_destination_mgr_mem;

typedef sw_destination_mgr_mem *sw_dest_ptr_mem;

// SW! copy and paste from jdatadst.c

#define OUTPUT_BUF_SIZE  4096	/* choose an efficiently fwrite'able size */

// SW! copy and paste from jdatadst.c END

METHODDEF(void)
init_destination_mem (j_compress_ptr cinfo)
{
  sw_dest_ptr_mem dest = (sw_dest_ptr_mem) cinfo->dest;

  /* Allocate the output buffer --- it will be released when done with image */
  dest->buffer = (JOCTET *)
      (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				  OUTPUT_BUF_SIZE * SIZEOF(JOCTET));

  dest->pub.next_output_byte = dest->buffer;
  dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
  dest->jpeg_buffer_offset = 0; // SW!
}


METHODDEF(boolean)
empty_output_buffer_mem (j_compress_ptr cinfo)
{
  sw_dest_ptr_mem dest = (sw_dest_ptr_mem) cinfo->dest;

  memcpy( (void *) &(dest->jpeg_buffer[dest->jpeg_buffer_offset]), dest->buffer, OUTPUT_BUF_SIZE);
  dest->jpeg_buffer_offset+=OUTPUT_BUF_SIZE;

  dest->pub.next_output_byte = dest->buffer;
  dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;

  return TRUE;
}


METHODDEF(void)
term_destination_mem (j_compress_ptr cinfo)
{
  sw_dest_ptr_mem dest = (sw_dest_ptr_mem) cinfo->dest;
  size_t datacount = OUTPUT_BUF_SIZE - dest->pub.free_in_buffer;

  memcpy( (void *) &(dest->jpeg_buffer[dest->jpeg_buffer_offset]), (const void *) dest->buffer, datacount);
  dest->jpeg_buffer_offset+=datacount;

  dest->jpeg_buffer_length_used = dest->jpeg_buffer_offset;
}


// if 0 is returned, compression has not yet been finished
// if >0 is returned, this is the size of buffer that has been used
GLOBAL(void)
jpeg_membuf_getUsedLength (j_compress_ptr cinfo, unsigned int *jpegmembufSizeBytesUsed)
{
  sw_dest_ptr_mem dest = (sw_dest_ptr_mem) cinfo->dest;

  if (jpegmembufSizeBytesUsed != NULL) *jpegmembufSizeBytesUsed = dest->jpeg_buffer_length_used;
}


GLOBAL(void)
jpeg_membuf_dest (j_compress_ptr cinfo, unsigned char *jpegmembuf, unsigned int jpegmembufSizeBytes)
{
  sw_dest_ptr_mem dest;

  /* The destination object is made permanent so that multiple JPEG images
   * can be written to the same file without re-executing jpeg_stdio_dest.
   * This makes it dangerous to use this manager and a different destination
   * manager serially with the same JPEG object, because their private object
   * sizes may be different.  Caveat programmer.
   */
  if (cinfo->dest == NULL) {	/* first time for this JPEG object? */
    cinfo->dest = (struct jpeg_destination_mgr *)
      (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
				  SIZEOF(sw_destination_mgr_mem));
  }

  dest = (sw_dest_ptr_mem) cinfo->dest;
  dest->pub.init_destination = init_destination_mem;
  dest->pub.empty_output_buffer = empty_output_buffer_mem;
  dest->pub.term_destination = term_destination_mem;
  dest->jpeg_buffer = jpegmembuf;
  dest->jpeg_buffer_size = jpegmembufSizeBytes;
  dest->jpeg_buffer_length_used = 0;
  dest->jpeg_buffer_offset = 0;
}

// =======================================================================================================
// =======================================================================================================
// =======================================================================================================
// down is c&p from wrbmp.c, then changed to be a raw memory destination

//#ifdef __SW_WRITE_MEM_SUPPORTED__

// bmp -> write_mem

/*
 * wrbmp.c
 *
 * Copyright (C) 1994-1996, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains routines to write output images in Microsoft "BMP"
 * format (MS Windows 3.x and OS/2 1.x flavors).
 * Either 8-bit colormapped or 24-bit full-color format can be written.
 * No compression is supported.
 *
 * These routines may need modification for non-Unix environments or
 * specialized applications.  As they stand, they assume output to
 * an ordinary stdio stream.
 *
 * This code contributed by James Arthur Boucher.
 */

//#include "cdjpeg.h"		/* Common decls for cjpeg/djpeg applications */

/*
 * To support 12-bit JPEG data, we'd have to scale output down to 8 bits.
 * This is not yet implemented.
 */


#if BITS_IN_JSAMPLE != 8
  Sorry, this code only copes with 8-bit JSAMPLEs. /* deliberate syntax err */
#endif

/*
 * Since BMP stores scanlines bottom-to-top, we have to invert the image
 * from JPEG's top-to-bottom order.  To do this, we save the outgoing data
 * in a virtual array during put_pixel_row calls, then actually emit the
 * BMP file during finish_output.  The virtual array contains one JSAMPLE per
 * pixel if the output is grayscale or colormapped, three if it is full color.
 */

/* Private version of data destination object */

typedef struct {
  struct djpeg_dest_struct pub;	/* public fields */

  jvirt_sarray_ptr memory_location;
  int memory_location_size_bytes;

  //jvirt_sarray_ptr whole_image;	/* needed to reverse row order */

  JDIMENSION data_width;	/* JSAMPLEs per row */
  JDIMENSION row_width;		/* physical width of one row in the BMP file */
  //int pad_bytes;		/* number of padding bytes needed per row */
  JDIMENSION cur_output_row;	/* next row# to write to virtual array */
} write_mem_dest_struct;

typedef write_mem_dest_struct * write_mem_dest_ptr;


/* Forward declarations */
/*LOCAL(void) write_colormap
	JPP((j_decompress_ptr cinfo, write_mem_dest_ptr dest,
	     int map_colors, int map_entry_size));
*/

/*
 * Write some pixel data.
 * In this module rows_supplied will always be 1.
 */

METHODDEF(void)
put_pixel_rows (j_decompress_ptr cinfo, djpeg_dest_ptr dinfo,
		JDIMENSION rows_supplied)
/* This version is for writing 24-bit pixels */
{
  write_mem_dest_ptr dest = (write_mem_dest_ptr) dinfo;
  //JSAMPARRAY image_ptr;
  register JSAMPROW inptr, outptr;
  // register JDIMENSION col;
  //int pad;

  /* Access next row in virtual array */
  //image_ptr = (*cinfo->mem->access_virt_sarray)
  //  ((j_common_ptr) cinfo, dest->whole_image,
  //   dest->cur_output_row, (JDIMENSION) 1, TRUE);
  
  char *ptr = (char *) dest->memory_location;
  ptr += (dest->cur_output_row*dest->row_width);

  outptr = (JSAMPROW) ptr;
  
  dest->cur_output_row++;
  inptr = dest->pub.buffer[0];  

  memcpy(outptr, inptr, cinfo->output_width*3);

  /*

  // Transfer data.  Note destination values must be in BGR order
  // (even though Microsoft's own documents say the opposite).
  //
  inptr = dest->pub.buffer[0];
  //outptr = image_ptr[0];
  for (col = cinfo->output_width; col > 0; col--) {
    outptr[2] = *inptr++;	// can omit GETJSAMPLE() safely
    outptr[1] = *inptr++;
    outptr[0] = *inptr++;
    outptr += 3;
  }
  */

  /* Zero out the pad bytes. */
  //pad = dest->pad_bytes;
  //while (--pad >= 0)
  //  *outptr++ = 0;
}

METHODDEF(void)
put_gray_rows (j_decompress_ptr cinfo, djpeg_dest_ptr dinfo,
	       JDIMENSION rows_supplied)
/* This version is for grayscale color output */
{
  write_mem_dest_ptr dest = (write_mem_dest_ptr) dinfo;
  //JSAMPARRAY image_ptr;
  register JSAMPROW inptr, outptr;
  register JDIMENSION col;
  //int pad;

  /* Access next row in virtual array */
  //image_ptr = (*cinfo->mem->access_virt_sarray)
  //  ((j_common_ptr) cinfo, dest->whole_image,
  //   dest->cur_output_row, (JDIMENSION) 1, TRUE);

  char *ptr = (char *) dest->memory_location;
  ptr += (dest->cur_output_row*dest->row_width);

  outptr = (JSAMPROW) ptr;

  dest->cur_output_row++;

  /* Transfer data. */
  inptr = dest->pub.buffer[0];
  //outptr = image_ptr[0];
  for (col = cinfo->output_width; col > 0; col--) {
    *outptr++ = *inptr++;	/* can omit GETJSAMPLE() safely */
  }

  /* Zero out the pad bytes. */
  /*pad = dest->pad_bytes;
  while (--pad >= 0)
    *outptr++ = 0;*/
}


/*
 * Startup: normally writes the file header.
 * In this module we may as well postpone everything until finish_output.
 */

METHODDEF(void)
start_output_write_mem (j_decompress_ptr cinfo, djpeg_dest_ptr dinfo)
{
  /* no work here */
}


/*
 * Finish up at the end of the file.
 *
 * Here is where we really output the BMP file.
 *
 * First, routines to write the Windows and OS/2 variants of the file header.
 */

/*
LOCAL(void)
write_mem_dest_header (j_decompress_ptr cinfo, write_mem_dest_ptr dest)
// Write a Windows-style BMP file header, including colormap if needed 
{
  char bmpfileheader[14];
  char bmpinfoheader[40];
#define PUT_2B(array,offset,value)  \
	(array[offset] = (char) ((value) & 0xFF), \
	 array[offset+1] = (char) (((value) >> 8) & 0xFF))
#define PUT_4B(array,offset,value)  \
	(array[offset] = (char) ((value) & 0xFF), \
	 array[offset+1] = (char) (((value) >> 8) & 0xFF), \
	 array[offset+2] = (char) (((value) >> 16) & 0xFF), \
	 array[offset+3] = (char) (((value) >> 24) & 0xFF))
  INT32 headersize, bfSize;
  int bits_per_pixel, cmap_entries;

  // Compute colormap size and total file size 
  if (cinfo->out_color_space == JCS_RGB) {
    if (cinfo->quantize_colors) {
      // Colormapped RGB 
      bits_per_pixel = 8;
      cmap_entries = 256;
    } else {
      // Unquantized, full color RGB 
      bits_per_pixel = 24;
      cmap_entries = 0;
    }
  } else {
    // Grayscale output.  We need to fake a 256-entry colormap. 
    bits_per_pixel = 8;
    cmap_entries = 256;
  }
   // File size 
  headersize = 14 + 40 + cmap_entries * 4; // Header and colormap 
  bfSize = headersize + (INT32) dest->row_width * (INT32) cinfo->output_height;
  
  // Set unused fields of header to 0 
  MEMZERO(bmpfileheader, SIZEOF(bmpfileheader));
  MEMZERO(bmpinfoheader, SIZEOF(bmpinfoheader));

  // Fill the file header 
  bmpfileheader[0] = 0x42;	// first 2 bytes are ASCII 'B', 'M' 
  bmpfileheader[1] = 0x4D;
  PUT_4B(bmpfileheader, 2, bfSize); // bfSize 
  // we leave bfReserved1 & bfReserved2 = 0 
  PUT_4B(bmpfileheader, 10, headersize); // bfOffBits 

  // Fill the info header (Microsoft calls this a BITMAPINFOHEADER) 
  PUT_2B(bmpinfoheader, 0, 40);	// biSize 
  PUT_4B(bmpinfoheader, 4, cinfo->output_width); // biWidth 
  PUT_4B(bmpinfoheader, 8, cinfo->output_height); // biHeight
  PUT_2B(bmpinfoheader, 12, 1);	// biPlanes - must be 1 
  PUT_2B(bmpinfoheader, 14, bits_per_pixel); // biBitCount 
  // we leave biCompression = 0, for none 
  // we leave biSizeImage = 0; this is correct for uncompressed data 
  if (cinfo->density_unit == 2) { // if have density in dots/cm, then 
    PUT_4B(bmpinfoheader, 24, (INT32) (cinfo->X_density*100)); // XPels/M 
    PUT_4B(bmpinfoheader, 28, (INT32) (cinfo->Y_density*100)); // XPels/M 
  }
  PUT_2B(bmpinfoheader, 32, cmap_entries); // biClrUsed 
  // we leave biClrImportant = 0 

  if (JFWRITE(dest->pub.output_file, bmpfileheader, 14) != (size_t) 14)
    ERREXIT(cinfo, JERR_FILE_WRITE);
  if (JFWRITE(dest->pub.output_file, bmpinfoheader, 40) != (size_t) 40)
    ERREXIT(cinfo, JERR_FILE_WRITE);

  if (cmap_entries > 0)
    write_colormap(cinfo, dest, cmap_entries, 4);

}
	*/


/*
 * Write the colormap.
 * Windows uses BGR0 map entries; OS/2 uses BGR entries.
 */
/*
LOCAL(void)
write_colormap (j_decompress_ptr cinfo, bmp_dest_ptr dest,
		int map_colors, int map_entry_size)
{
  JSAMPARRAY colormap = cinfo->colormap;
  int num_colors = cinfo->actual_number_of_colors;
  FILE * outfile = dest->pub.output_file;
  int i;

  if (colormap != NULL) {
    if (cinfo->out_color_components == 3) {
      // Normal case with RGB colormap 
      for (i = 0; i < num_colors; i++) {
	putc(GETJSAMPLE(colormap[2][i]), outfile);
	putc(GETJSAMPLE(colormap[1][i]), outfile);
	putc(GETJSAMPLE(colormap[0][i]), outfile);
	if (map_entry_size == 4)
	  putc(0, outfile);
      }
    } else {
      // Grayscale colormap (only happens with grayscale quantization) 
      for (i = 0; i < num_colors; i++) {
	putc(GETJSAMPLE(colormap[0][i]), outfile);
	putc(GETJSAMPLE(colormap[0][i]), outfile);
	putc(GETJSAMPLE(colormap[0][i]), outfile);
	if (map_entry_size == 4)
	  putc(0, outfile);
      }
    }
  } else {
    // If no colormap, must be grayscale data.  Generate a linear "map".
    for (i = 0; i < 256; i++) {
      putc(i, outfile);
      putc(i, outfile);
      putc(i, outfile);
      if (map_entry_size == 4)
	putc(0, outfile);
    }
  }
  // Pad colormap with zeros to ensure specified number of colormap entries 
  if (i > map_colors)
    ERREXIT1(cinfo, JERR_TOO_MANY_COLORS, i);
  for (; i < map_colors; i++) {
    putc(0, outfile);
    putc(0, outfile);
    putc(0, outfile);
    if (map_entry_size == 4)
      putc(0, outfile);
  }
  
}
*/

METHODDEF(void)
finish_output_write_mem (j_decompress_ptr cinfo, djpeg_dest_ptr dinfo)
{
	//nothing to do in here
	/*
  write_mem_dest_ptr dest = (write_mem_dest_ptr) dinfo;
  register FILE * outfile = dest->pub.output_file;
  JSAMPARRAY image_ptr;
  register JSAMPROW data_ptr;
  JDIMENSION row;
  register JDIMENSION col;
  cd_progress_ptr progress = (cd_progress_ptr) cinfo->progress;
	*/

  /* Write the header and colormap */
  //if (dest->is_os2)
  //  write_os2_header(cinfo, dest);
  //else
  //  write_bmp_header(cinfo, dest);

  /* Write the file body from our virtual array */
  /*for (row = cinfo->output_height; row > 0; row--) {
    if (progress != NULL) {
      progress->pub.pass_counter = (long) (cinfo->output_height - row);
      progress->pub.pass_limit = (long) cinfo->output_height;
      (*progress->pub.progress_monitor) ((j_common_ptr) cinfo);
    }
    image_ptr = (*cinfo->mem->access_virt_sarray)
      ((j_common_ptr) cinfo, dest->whole_image, row-1, (JDIMENSION) 1, FALSE);
    data_ptr = image_ptr[0];
    for (col = dest->row_width; col > 0; col--) {
      putc(GETJSAMPLE(*data_ptr), outfile);
      data_ptr++;
    }
  }*/


  /* Make sure we wrote the output file OK */
  //fflush(outfile);
  //if (ferror(outfile))
  //  ERREXIT(cinfo, JERR_FILE_WRITE);
}


/*
 * The module selection routine for MEMORY format output.
 */


GLOBAL(djpeg_dest_ptr)
jinit_write_to_memory (j_decompress_ptr cinfo, const void *aDest, const int aDestSizeBytes)
{
  write_mem_dest_ptr dest;
  JDIMENSION row_width;

  /* Create module interface object, fill in method pointers */
  dest = (write_mem_dest_ptr)
      (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				  SIZEOF(write_mem_dest_struct));

  dest->pub.start_output = start_output_write_mem;
  dest->pub.finish_output = finish_output_write_mem;

//  dest->memory_location = (void *) aDest;
  dest->memory_location = (jvirt_sarray_control*) aDest;  
  
  dest->memory_location_size_bytes = (int) aDestSizeBytes;

  if (cinfo->out_color_space == JCS_GRAYSCALE) {
    dest->pub.put_pixel_rows = put_gray_rows;
  } else if (cinfo->out_color_space == JCS_RGB) {
    if (!cinfo->quantize_colors)
      dest->pub.put_pixel_rows = put_pixel_rows;
  } else {
//    ERREXIT(cinfo, JERR_MEM_COLORSPACE);
  }

  /* Calculate output image dimensions so we can allocate space */
  jpeg_calc_output_dimensions(cinfo);

  
  row_width = cinfo->output_width * cinfo->output_components;
  dest->data_width = row_width;
  
  dest->row_width = row_width;
  //dest->pad_bytes = (int) (row_width - dest->data_width);

  /* Allocate space for inversion array, prepare for write pass */
  /*dest->whole_image = (*cinfo->mem->request_virt_sarray)
    ((j_common_ptr) cinfo, JPOOL_IMAGE, FALSE,
     row_width, cinfo->output_height, (JDIMENSION) 1);*/
  
  dest->cur_output_row = 0;
  
  /*
  if (cinfo->progress != NULL) {
    cd_progress_ptr progress = (cd_progress_ptr) cinfo->progress;
  }
  */

  /* Create decompressor output buffer. */
  dest->pub.buffer = (*cinfo->mem->alloc_sarray)
    ((j_common_ptr) cinfo, JPOOL_IMAGE, row_width, (JDIMENSION) 1);
  dest->pub.buffer_height = 1;

  return (djpeg_dest_ptr) dest;
}


bool internalDecompressJPEG(const void *aSrc, const int aSrcLength, void *aDest, unsigned int aDestSizeBytes, int &aOutWidth, int &aOutHeight, int &aOutFormat)
{
	// c&p, then adjusted from djpeg.c
	
	struct jpeg_decompress_struct dinfo;
	struct jpeg_error_mgr jerr;

	djpeg_dest_ptr dest_mgr = NULL;

	bool retB = false;
 
	/* Initialize the JPEG decompression object with default error handling. */
	dinfo.err = jpeg_std_error(&jerr);
	jpeg_create_decompress(&dinfo);

	/* Specify data source for decompression */
	jpeg_mem_src(&dinfo, (unsigned char *) aSrc, aSrcLength);

	/* Read file header, set default decompression parameters */
	(void) jpeg_read_header(&dinfo, TRUE);

	if ((dinfo.jpeg_color_space == JCS_GRAYSCALE) || (dinfo.jpeg_color_space == JCS_RGB) || (dinfo.jpeg_color_space == JCS_YCbCr) )
	{
		if (((dinfo.jpeg_color_space == JCS_GRAYSCALE) && (dinfo.num_components == 1)) ||
			((dinfo.jpeg_color_space == JCS_RGB) && (dinfo.num_components == 3)) ||
			((dinfo.jpeg_color_space == JCS_YCbCr) && (dinfo.num_components == 3)))
		{
			if (aDestSizeBytes >= (dinfo.image_width*dinfo.image_width*dinfo.num_components))
			{
				/* only for reference: NO SOURCECODE
				cinfo.image_width = aWidth; 	 image width and height, in pixels 
				cinfo.image_height = aHeight;
				cinfo.input_components = 1;	 # of color components per pixel 
				cinfo.in_color_space = JCS_GRAYSCALE;  arbitrary guess 
				*/

				if (dinfo.out_color_space != JCS_GRAYSCALE) dinfo.out_color_space = JCS_RGB;

				/* Specify data destination for compression */
				dest_mgr = jinit_write_to_memory(&dinfo, aDest, aDestSizeBytes);
				//jpeg_membuf_dest(&dinfo, (unsigned char *) aDest, aDestSizeBytes);

				/* Start decompressor */
				(void) jpeg_start_decompress(&dinfo);

				/* Write output file header */
				(*dest_mgr->start_output) (&dinfo, dest_mgr);

				/* Process data */
				while (dinfo.output_scanline < dinfo.output_height) 
				{
					int num_scanlines = jpeg_read_scanlines(&dinfo, dest_mgr->buffer,
									dest_mgr->buffer_height);
					(*dest_mgr->put_pixel_rows) (&dinfo, dest_mgr, num_scanlines);
				}


				/* Finish decompression and release memory.
				* I must do it in this order because output module has allocated memory
				* of lifespan JPOOL_IMAGE; it needs to finish before releasing memory.
				*/
				(*dest_mgr->finish_output) (&dinfo, dest_mgr);
				(void) jpeg_finish_decompress(&dinfo);

				retB = true;
				
				aOutWidth = dinfo.image_width;
				aOutHeight = dinfo.image_height;
				aOutFormat = 0;

				if (dinfo.out_color_space == JCS_RGB) aOutFormat = 1;
			}
		}
	}
	
	jpeg_destroy_decompress(&dinfo);

	return retB;
}

//???????????????????????????????????????????????????????????????
//ffffffffffffffffffffffffffffffffffffffffffff


void infofuncionVSV2(VIDHDR &DI, mxArray * &lsp)
{
	const char *field_names[] = {
											"kennung",
											"compression",
											"len_total",
											"len_data",
											"len_fmthdr",
											"frameno",
											"cameraport",
											"widthframe",
											"heightframe",
											"compressed",
											"scale",
											"bpp",
											"bpp_effective",

											"timestampSeconds",	
											"timestampMicroseconds"
										 };	

   //mwSize dims[2] = {1,1};	
   //mwIndex i = 0;
   int dims[2] = {1,1};	
   int i = 0;
	
	int  NUMBER_OF_FIELDS = 15;
   lsp = mxCreateStructArray(2, dims, NUMBER_OF_FIELDS, field_names);

	char Seconds[60];
	char Microseconds[60];
	char kennunG[60];
	char Compression[60];
	
	
	sprintf(kennunG,"0x%x",DI.kennung);
	sprintf(Compression,"%u",DI.compression);
			
	sprintf(Seconds,"%d",DI.timestamp.time);
	sprintf(Microseconds,"%d",DI.timestamp.millitm);
	
	mxSetField(lsp,i,"kennung",              mxCreateString(kennunG));		
	mxSetField(lsp,i,"compression",          mxCreateString(Compression));			
	mxSetField(lsp,i,"len_total",            mxCreateDoubleScalar(DI.len_total));		
	mxSetField(lsp,i,"len_data",             mxCreateDoubleScalar(DI.len_data));		
	mxSetField(lsp,i,"len_fmthdr",           mxCreateDoubleScalar(DI.len_fmthdr));			
	mxSetField(lsp,i,"frameno",              mxCreateDoubleScalar(DI.frameno));
	mxSetField(lsp,i,"cameraport",           mxCreateDoubleScalar(DI.cameraport));	
	mxSetField(lsp,i,"widthframe",           mxCreateDoubleScalar(DI.widthframe));
	mxSetField(lsp,i,"heightframe",          mxCreateDoubleScalar(DI.heightframe));
	mxSetField(lsp,i,"compressed",           mxCreateDoubleScalar(DI.compressed));	
	mxSetField(lsp,i,"scale",                mxCreateDoubleScalar(DI.scale));	
	mxSetField(lsp,i,"bpp",                  mxCreateDoubleScalar(DI.bpp));
	mxSetField(lsp,i,"bpp_effective",        mxCreateDoubleScalar(DI.bpp_effective));	
	
	mxSetField(lsp,i,"timestampSeconds",     mxCreateString(Seconds));
	mxSetField(lsp,i,"timestampMicroseconds",mxCreateString(Microseconds));		
			
}


void infofuncionVSV3(DIMAGE &DI, mxArray * &lsp)
{
	const char *field_names[] = {
											"baseTag",
											"cameraPortId",	
											"versionTag",	
											"totalLength",
											"timestampSeconds",	
											"timestampMicroseconds",	
											"cameraPortName",

											"sourceWidth",
											"sourceHeight",	
											"aoiWidth",
											"aoiHeight",	
											"xStart",	
											"yStart",
											"bytesPerPixel",	
											"effectiveBitsPerPixel",	
											"horizontalBinning",
											"verticalBinning",	
											"sourceFormat",	
											"imageFormat",	
											"frameNumber",	
											"eventNumber",	
											"xScale",
											"yScale",	
											"imageRotation",	
											"fspare1",	
											"fspare2",	
											"fspare3",	
											"imageFlags",	
											"ispare1",
											"ispare2",	
											"ispare3",
											"appendedFrameSize"
										 };	
	
   int dims[2] = {1,1};	
   int i = 0;
	
	int  NUMBER_OF_FIELDS = 32;
   lsp = mxCreateStructArray(2, dims, NUMBER_OF_FIELDS, field_names);
	
	char Seconds[60];
	char Microseconds[60];
	sprintf(Seconds,"%d",DI.sourceHeader.timestampSeconds);
	sprintf(Microseconds,"%d",DI.sourceHeader.timestampMicroseconds);		
	
	mxSetField(lsp,i,"baseTag",              mxCreateDoubleScalar(DI.sourceHeader.baseTag));	
	mxSetField(lsp,i,"cameraPortId",         mxCreateDoubleScalar(DI.sourceHeader.cameraPortId));		
	mxSetField(lsp,i,"versionTag",           mxCreateDoubleScalar(DI.sourceHeader.versionTag));	
	mxSetField(lsp,i,"totalLength",          mxCreateDoubleScalar(DI.sourceHeader.totalLength));		 
//	mxSetField(lsp,i,"timestampSeconds",     mxCreateDoubleScalar((int32_T)(DI.sourceHeader.timestampSeconds)));
	mxSetField(lsp,i,"timestampSeconds",     mxCreateString(Seconds));	
//	mxSetField(lsp,i,"timestampMicroseconds",mxCreateDoubleScalar(DI.sourceHeader.timestampMicroseconds));	
	mxSetField(lsp,i,"timestampMicroseconds",mxCreateString(Microseconds));	
	mxSetField(lsp,i,"cameraPortName",       mxCreateString(DI.sourceHeader.cameraPortName));	
	
	mxSetField(lsp,i,"sourceWidth",          mxCreateDoubleScalar(DI.frameHeader.sourceWidth));	 
	mxSetField(lsp,i,"sourceHeight",         mxCreateDoubleScalar(DI.frameHeader.sourceHeight));	
	mxSetField(lsp,i,"aoiWidth",             mxCreateDoubleScalar(DI.frameHeader.aoiWidth));		
	mxSetField(lsp,i,"aoiHeight",            mxCreateDoubleScalar(DI.frameHeader.aoiHeight));	
	mxSetField(lsp,i,"xStart",               mxCreateDoubleScalar(DI.frameHeader.xStart));		 
	mxSetField(lsp,i,"yStart",               mxCreateDoubleScalar(DI.frameHeader.yStart));	
	mxSetField(lsp,i,"bytesPerPixel",        mxCreateDoubleScalar(DI.frameHeader.bytesPerPixel));		
	mxSetField(lsp,i,"effectiveBitsPerPixel",mxCreateDoubleScalar(DI.frameHeader.effectiveBitsPerPixel));	
	mxSetField(lsp,i,"horizontalBinning",    mxCreateDoubleScalar(DI.frameHeader.horizontalBinning));
	mxSetField(lsp,i,"verticalBinning",      mxCreateDoubleScalar(DI.frameHeader.verticalBinning));	
	mxSetField(lsp,i,"sourceFormat",         mxCreateDoubleScalar(DI.frameHeader.sourceFormat));		
	mxSetField(lsp,i,"imageFormat",          mxCreateDoubleScalar(DI.frameHeader.imageFormat));	
	mxSetField(lsp,i,"frameNumber",          mxCreateDoubleScalar(DI.frameHeader.frameNumber));		 
	mxSetField(lsp,i,"eventNumber",          mxCreateDoubleScalar(DI.frameHeader.eventNumber));	
	mxSetField(lsp,i,"xScale",               mxCreateDoubleScalar(DI.frameHeader.xScale));		
	mxSetField(lsp,i,"yScale",               mxCreateDoubleScalar(DI.frameHeader.yScale));	
	mxSetField(lsp,i,"imageRotation",        mxCreateDoubleScalar(DI.frameHeader.imageRotation));	 
	mxSetField(lsp,i,"fspare1",              mxCreateDoubleScalar(DI.frameHeader.fspare1));	
	mxSetField(lsp,i,"fspare2",              mxCreateDoubleScalar(DI.frameHeader.fspare2));		
	mxSetField(lsp,i,"fspare3",              mxCreateDoubleScalar(DI.frameHeader.fspare3));	
	mxSetField(lsp,i,"imageFlags",           mxCreateDoubleScalar(DI.frameHeader.imageFlags));		 
	mxSetField(lsp,i,"ispare1",              mxCreateDoubleScalar(DI.frameHeader.ispare1));	
	mxSetField(lsp,i,"ispare2",              mxCreateDoubleScalar(DI.frameHeader.ispare2));		
	mxSetField(lsp,i,"ispare3",              mxCreateDoubleScalar(DI.frameHeader.ispare3));	
	mxSetField(lsp,i,"appendedFrameSize",    mxCreateDoubleScalar(DI.frameHeader.appendedFrameSize));	
}


//ffffffffffffffffffffffffffffffffffffffffffff
BYTE **getDoubleByteArray(int ix, int iy)
{
  int i,cc=0;
  BYTE **c=NULL;
  if (ix < 1 || iy < 1) ccerr(argument_list_error);
  if ((c=(BYTE **)malloc(ix*sizeof(BYTE *))) == NULL) ccerr(out_of_local_memory);
  for (i=0; i<ix; i++)
  {
    if (((BYTE *)c[i]=(BYTE *)malloc(iy)) == NULL)
    {
      mexPrintf("allocation problem !\n");
      return NULL;
    }
  }
err:
  if (cc != 0) mexPrintf("getDoubleByteArray failed : %d\n",cc);
  return c;
}
void freeDoubleArray(BYTE **a,int len)
{
  int i;
  if (a == NULL) return;
  for (i=0; i<len; i++) 
  {
    if (a[i] != NULL) free(a[i]);
  }
  free(a);
}
u_int **getDoubleUintArray(int ix, int iy)
{
  int i;
  u_int **c;
  if (ix < 1 || iy < 1) return NULL;
  if ((c=(u_int **)malloc(ix*sizeof(u_int *))) == NULL) return NULL;
  for (i=0; i<ix; i++)
  {
    if (((u_int *)c[i]=(u_int *)malloc(iy*sizeof(u_int))) == NULL)
    {
      mexPrintf("allocation problem !\n");
      return NULL;
    }
  }
  return c;
}
void freeDoubleUintArray(u_int **a,int len)
{
  int i;
  if (a == NULL) return;
  for (i=0; i<len; i++) 
  {
    if (a[i] != NULL) free(a[i]);
  }
  free(a);
}
u_short **getDoubleUShortArray(int ix, int iy)
{
  int i;
  u_short **c;
  if (ix < 1 || iy < 1) return NULL;
  if ((c=(u_short **)malloc(ix*sizeof(u_short *))) == NULL) return NULL;
  for (i=0; i<ix; i++)
  {
    if (((u_short *)c[i]=(u_short *)malloc(iy*sizeof(u_short))) == NULL)
    {
      mexPrintf("allocation problem !\n");
      return NULL;
    }
  }
  return c;
}
void freeDoubleUShortArray(u_short **a,int len)
{
  int i;
  if (a == NULL) return;
  for (i=0; i<len; i++) 
  {
    if (a[i] != NULL) free(a[i]);
  }
  free(a);
}

long				filesize;
int				i,bperpix,sz,wi,hi;


int len;
int w;
int h;

BYTE			  *bp;
BYTE			  *bb;
u_short          *bb16;
u_int            *bb32;

int         bytesPerPixel;	
int	effectiveBitsPerPixel;
int   imageFormat;

int read_prop(char *dev, char *prop, int *fmt, int *size, char *tag)
{ 
  PropertyQueryStruct	svrProp; // legacy
  PrpQueryStruct pqs;
  DTYPE dout, din;
  int cc, isLegacy=FALSE;
  char *prp = "PROPS";

  if ((cc=getPropertyInfoFromListenerEx(dev,prop,size,fmt,tag)) == 0)
  {
    return 0;
  }
  memset(&din,0,sizeof(DTYPE));
  din.dFormat = CF_TEXT;
  din.dArrayLength = (int)strlen(prop);
  din.data.vptr = prop;

  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = 1;
  dout.data.vptr = &pqs;
  strcpy(dout.dTag,"PRPQSr4");

legacyRetry:
  if ((cc=alsnExecLink(dev,prp,&dout,&din,CA_READ,500)) != 0)
  {
    if (!isLegacy && (cc == illegal_format || cc == invalid_structure_tag))
    {
      isLegacy = TRUE;
      dout.dFormat = CF_STRUCT;
      dout.dArrayLength = PROPERTYQUERYSTRUCT_SIZE;
      dout.data.vptr = &svrProp;
      dout.dTag[0] = '\0';
      goto legacyRetry;
    }
    *size = 0;
    return cc;
 	}

  if (isLegacy)
  {
    *size = svrProp.prpSize;
    *fmt = LFMT(svrProp.prpFormat);
  }
  else
  {
    *size = pqs.prpSize;
    *fmt = LFMT(pqs.prpFormat);
    if (tag != NULL) strncpy(tag,pqs.prpTag,TAG_NAME_SIZE);
  }
  return 0;
}

int hasAcquiredFrame = FALSE;
#define mxerr(s) { mxerrStr = (char *)s; goto err; }
#define MAX_TRANSPORT_SIZE (1024*1024*6)
unsigned int imageFrameBufferSize = MAX_TRANSPORT_SIZE;	
unsigned char pTineVideoBuffer[MAX_TRANSPORT_SIZE];

#define usageStr "tine_readimage usage:\n [a,h,s,t]=tine_readimage('/<context>/<server>/<device>[<property>]'[,polling_interval,'access_mode']);\n'ret' contains the image, image header, status, timestamp"
void mexFunction (int lcnt, mxArray *lsp [], int rcnt, const mxArray *rsp [])
{
  int		   err,ix,iy,ixo,iyo,iopt;
  int		   cnt;
  u_int		   i, j, ndim, n;
  int		   dims[3];
  double *lp, dt = (double)time(NULL);;	
  double koef = .1;
  int fmt, siz, tmr = 0;
  char dsc[64], *c, *prp="Frame", *dev, *mxerrStr=NULL;
  int ret, acc = CA_READ;
  char tsstr[64], dtstr[32];
  char *accstr = NULL;
  char *tinedevicestringbuffer = NULL;
  char *tinepropertyname = NULL;	

  if (lsp == NULL || rsp == NULL) return;

  /* Check for proper number of arguments. */
  switch (rcnt)
  {
    case 4:
      if (!mxIsDouble(rsp[3])) mxerr(usageStr);
      koef = mxGetScalar(rsp[3]);
    case 3:
      if(!mxIsChar(rsp[2])) mxerr(usageStr);
      cnt = mxGetN(rsp[0]) + 1;
      accstr = (char *) mxCalloc(cnt, sizeof (char));
      mxGetString(rsp[0], accstr, cnt);
      // check for some specific transport 'mode' specifications buried in the access string:
      if (strstr(accstr,"NETWORK") != NULL || strstr(accstr,"MCAST") != NULL || strstr(accstr,"MULTICAST") != NULL)
      {
        acc |= CA_NETWORK;
      }
      else if (strstr(accstr,"CONNECT") != NULL) 
      {
        acc |= CA_CONNECT;
      }
      if (strstr(accstr,"SYNC") != NULL) 
      {
        acc |= CA_SYNC;
      }
      acc |= GetAccessMode(accstr);
    case 2:
      if (!mxIsDouble(rsp[1])) mxerr(usageStr);
      if (mxGetM(rsp[1]) != 1) mxerr(usageStr);
      tmr = (int)mxGetScalar(rsp[1]);
    case 1:
      if(!mxIsChar(rsp[0])) mxerr(usageStr);
      cnt = mxGetN(rsp[0]) + 1;
      tinedevicestringbuffer = (char *) mxCalloc(cnt, sizeof (char));
      mxGetString(rsp[0], tinedevicestringbuffer, cnt);
      if ((c=strchr(tinedevicestringbuffer,'[')) != NULL)
      {
        *c++ = 0;
        prp = c;
        if ((c=strchr(prp,']')) != NULL) *c = 0;
      }
      dev = tinedevicestringbuffer;
      break;
    default:
      mxerr(usageStr);
  }  
  ret = read_prop(dev,prp,&fmt,&siz,NULL);
  if(ret != 0)
  {
    lsp[0] = mxCreateString("");
    lsp[1] = mxCreateString("");		
    lsp[2] = mxCreateString(GetRPCLastError(ret));
    if(lcnt > 3) lsp[3] = mxCreateString("");
    if(lcnt > 4) lsp[4] = mxCreateString("");
    if(lcnt > 5) lsp[5] = mxCreateString("");
    return;	
  }
  //if (siz > MAX_TRANSPORT_SIZE) siz = MAX_TRANSPORT_SIZE;
  siz = MAX_TRANSPORT_SIZE; // hard-wire this according to Stefan ...
  if(fmt == CF_BYTE)    
  { //vsv2
    DTYPE	dout;
    memset(&dout,0,sizeof(DTYPE));
    dout.dFormat = CF_BYTE;		
    dout.dArrayLength = siz;		
    dout.data.bptr = (BYTE*)pTineVideoBuffer;			
    //ret = ExecLink(dev,prp, &dout, NULL, CA_READ);	
    ret = alsnExecLinkEx(dev,prp, &dout, NULL, acc,tmr,&dt);
    if (tinedevicestringbuffer != NULL) mxFree(tinedevicestringbuffer);	
    if (tinepropertyname != NULL) mxFree(tinepropertyname);

    if(ret != 0)
    {
      lsp[0] = mxCreateString("");
      lsp[1] = mxCreateString("");			
      lsp[2] = mxCreateString(GetRPCLastError(ret));
      if(lcnt > 3) lsp[3] = mxCreateString("");
      if(lcnt > 4) lsp[4] = mxCreateString("");
      if(lcnt > 5) lsp[5] = mxCreateString("");
      return;	
    }				
    if(lcnt > 3) 
    {
      strncpy(tsstr,getDataTimeString(dt,0),64);
      sprintf(dtstr,"%10.3f",dt);
      lsp[3] = mxCreateString(dtstr);
    }

    VIDHDR				lvidH;
    UCHAR   vidhdr_stream[REAL_SIZE_VIDHDR];

    ret = translate_charstream_into_vidhdr( &lvidH, pTineVideoBuffer);				

    if (ret != 0)
    {
      mexPrintf("Error: translate_charstream_into_vidhdr %d\n",ret);
      return;
    }	

    struct VIDINFHDR vinf;	

    initialize_vidinfhdr( &vinf );

    vinf.type = TYPE_IMM;	

    UINT32   num_frames = 1;	
    UINT32	lnumframes = 0;		

    vinf.framebits = (VOIDP *) malloc( num_frames*sizeof( VOIDP ) );	
    memset( vinf.framebits, 0, num_frames*sizeof( VOIDP ) );	
    vinf.framescales = (DOUBLE *) malloc( num_frames*sizeof( DOUBLE ) );	
    vinf.numframes = num_frames;	

    UCHAR *compressed_ptr = (UCHAR *) (pTineVideoBuffer+88+lvidH.len_fmthdr);		

    vinf.framebits[lnumframes] = (VOIDP) malloc( (lvidH.widthframe*lvidH.heightframe*lvidH.bpp)/8 );	

    vinf.bpp = lvidH.bpp;
    vinf.bpp_effective = lvidH.bpp_effective;
    vinf.height = lvidH.heightframe;
    vinf.width = lvidH.widthframe;
    vinf.scale = lvidH.scale;
    vinf.framescales[lnumframes] = lvidH.scale;

    UINT32 uncompressed_length = (lvidH.widthframe*lvidH.heightframe*lvidH.bpp)/8;	

    if (lvidH.compressed == 1) // compressed frame ? 
    {
      decompress_huffyuv( vinf.framebits[lnumframes], (const VOIDP) compressed_ptr, uncompressed_length ); // decompress it
    }
    else
    {
      memcpy( vinf.framebits[lnumframes], (const VOIDP) compressed_ptr, uncompressed_length ); // uncompressed: just copy frame
    }//varblock3			
		
    ix   = vinf.height;
    iy   = vinf.width;		

    bytesPerPixel = vinf.bpp;		

    if(koef < 0.000001) koef = 0.000001;		

    effectiveBitsPerPixel = vinf.bpp_effective;		
		    
    n = iy*ix;		

    if(bytesPerPixel == 8)	
    {
      bb = (BYTE*)( vinf.framebits[lnumframes] );			
      BYTE **testbb = getDoubleByteArray(ix,iy);;
      BYTE **testbb_rot = getDoubleByteArray(iy,ix);

      if(effectiveBitsPerPixel < 8)
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb[i];
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) << (8-effectiveBitsPerPixel);
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) >> (8-effectiveBitsPerPixel);				
        }		
      }
      else
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb[i];
        }		
      }
      for(i=0; i < ix; i++)
      {
        for(j=0; j < iy; j++)			
        {
          testbb_rot[j][i] = testbb[i][j];
        }		
      }
      dims[0] = ix;		
      dims[1] = iy;
      ndim = 2;
      lsp[0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
      lp = (double *) mxGetPr(lsp[0]);	

      for(i=0; i < n; i++)
      {
        lp[i] = ((double)(testbb_rot[i/ix][i%ix]))*koef;			 			
      }
      infofuncionVSV2(lvidH, lsp[1]);				
      lsp[2] = mxCreateString ("");
      freeDoubleArray(testbb,ix);
      freeDoubleArray(testbb_rot,iy);
      //if (testbb != NULL) free(testbb);
      //if (testbb_rot != NULL) free(testbb_rot);
      return;	
    }			
  }

  if(fmt == CF_IMAGE)    
  { //vsv3
    DIMAGE	dimage;
    dimage.frameBufferSize = imageFrameBufferSize;
    dimage.frameBuffer = pTineVideoBuffer;
    DTYPE	dout;
    memset(&dout,0,sizeof(DTYPE));
    dout.dFormat = CF_IMAGE;
    dout.dArrayLength = siz;
    dout.data.vptr = &dimage;
    //ret = ExecLink(dev,prp, &dout, NULL, CA_READ);
    ret = alsnExecLinkEx(dev,prp, &dout, NULL, acc,tmr,&dt);
    if (tinedevicestringbuffer != NULL) mxFree(tinedevicestringbuffer);	
    if (tinepropertyname != NULL) mxFree(tinepropertyname);			
    if(ret != 0)
    {
      lsp[0] = mxCreateString("");
      if(lcnt > 1) lsp[1] = mxCreateString("");
      if(lcnt > 2) lsp[2] = mxCreateString(GetRPCLastError(ret));
      if(lcnt > 3) lsp[3] = mxCreateString("");
      if(lcnt > 4) lsp[4] = mxCreateString("");
      if(lcnt > 5) lsp[5] = mxCreateString("");
      if (ret == 516 && !hasAcquiredFrame) return;	
    }		
    if(lcnt > 3) 
    {
      strncpy(tsstr,getDataTimeString(dt,0),64);
      sprintf(dtstr,"%10.3f",dt);
      lsp[3] = mxCreateString(dtstr);
    }
    hasAcquiredFrame = TRUE;
    ix   = dimage.frameHeader.sourceHeight;
    iy   = dimage.frameHeader.sourceWidth;

    if(dimage.frameHeader.aoiHeight > 0) { ix = dimage.frameHeader.aoiHeight; }
    if(dimage.frameHeader.aoiWidth > 0)  { iy = dimage.frameHeader.aoiWidth; }
	    
    ixo  = dimage.frameHeader.yStart;
    iyo  = dimage.frameHeader.xStart;
    bytesPerPixel = dimage.frameHeader.bytesPerPixel;		
    if(koef < 0.000001) koef = 0.000001;		
    effectiveBitsPerPixel = dimage.frameHeader.effectiveBitsPerPixel;	
    imageFormat = dimage.frameHeader.imageFormat;				
    n = iy*ix;

    if( (bytesPerPixel == 1) && (imageFormat != 5) )
    {
      bb = (BYTE *)(dimage.frameBuffer);
      BYTE **testbb = getDoubleByteArray(ix,iy);;
      BYTE **testbb_rot = getDoubleByteArray(iy,ix);
      if(effectiveBitsPerPixel < 8)
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb[i];
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) << (8-effectiveBitsPerPixel);
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) >> (8-effectiveBitsPerPixel);				
        }		
      }
      else
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb[i];
        }		
      }
      for(i=0; i < ix; i++)
      {
        for(j=0; j < iy; j++)			
        {
          testbb_rot[j][i] = testbb[i][j];
        }		 
      }		
	    dims[0] = ix;		
	    dims[1] = iy;
	    ndim = 2;
	    lsp[0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
	    lp = (double *) mxGetPr(lsp[0]);	

	    for(i=0; i < n; i++)
	    {
        lp[i] = ((double)(testbb_rot[i/ix][i%ix]))*koef;			
	    }
	    infofuncionVSV3(dimage, lsp[1]);				
	    if (ret == 0) lsp[2] = mxCreateString ("");
      freeDoubleArray(testbb,ix);
      freeDoubleArray(testbb_rot,iy);
      //if (testbb != NULL) free(testbb);
      //if (testbb_rot != NULL) free(testbb_rot);
	    return ;			
    }

    if( (bytesPerPixel == 1) && (imageFormat == 5) )
    {
      int rWidth;
      int rHeight;
      int rFmt; // 0 == gray8, 1== RGB24
      BYTE *tmpBuffer=NULL;

      tmpBuffer = new BYTE[dimage.frameHeader.appendedFrameSize];
      if (tmpBuffer == NULL) 
      {
        mexPrintf("can't allocate new byte array\n");
        return;
      }
      memcpy(tmpBuffer, dimage.frameBuffer, dimage.frameHeader.appendedFrameSize);

      bool bret = internalDecompressJPEG(tmpBuffer, dimage.frameHeader.appendedFrameSize, 
		                           dimage.frameBuffer, dimage.frameBufferSize, rWidth, rHeight, rFmt);

      if (bret == true)
      {
        dimage.frameHeader.sourceFormat = CF_IMAGE_FORMAT_JPEG;

        dimage.frameHeader.imageFormat = CF_IMAGE_FORMAT_GRAY;
        dimage.frameHeader.bytesPerPixel = 1;
        dimage.frameHeader.effectiveBitsPerPixel = 8;

        if (rFmt == 1) // RGB24
        {
          dimage.frameHeader.imageFormat = CF_IMAGE_FORMAT_RGB;
          dimage.frameHeader.bytesPerPixel = 3;
          dimage.frameHeader.effectiveBitsPerPixel = 24;
        }

        dimage.frameHeader.appendedFrameSize = rWidth * rHeight * 
												        dimage.frameHeader.bytesPerPixel;
        // no aoi
        dimage.frameHeader.sourceWidth = rWidth;
        dimage.frameHeader.sourceHeight = rHeight;
        dimage.frameHeader.xStart = 0;
        dimage.frameHeader.yStart = 0;

        dimage.frameHeader.aoiWidth = -1;
        dimage.frameHeader.aoiHeight = -1;
      }
      else
      {
        memcpy(dimage.frameBuffer, tmpBuffer, dimage.frameHeader.appendedFrameSize);
      }

      if (tmpBuffer != NULL)
      {
        delete [] tmpBuffer;
        tmpBuffer = NULL;
      }		
		
      bb = (BYTE*)(dimage.frameBuffer);
      BYTE **testbb = getDoubleByteArray(ix,iy);;
      BYTE **testbb_rot = getDoubleByteArray(iy,ix);
      if(effectiveBitsPerPixel < 8)
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb[i];
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) << (8-effectiveBitsPerPixel);
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) >> (8-effectiveBitsPerPixel);				
        }		
      }
			else
      {
        for(i=0; i < n; i++)		
				{
          testbb[i/iy][i%iy] = bb[i];
				}		
			}
      for(i=0; i < ix; i++)
      {
        for(j=0; j < iy; j++)			
        {
          testbb_rot[j][i] = testbb[i][j];
        }		
      }		
      dims[0] = ix;		
      dims[1] = iy;
      ndim = 2;
      lsp[0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
      lp = (double *) mxGetPr(lsp[0]);	

      for(i=0; i < n; i++)
      {
        lp[i] = ((double)(testbb_rot[i/ix][i%ix]))*koef;			
      }
      infofuncionVSV3(dimage, lsp[1]);				
      lsp[2] = mxCreateString ("");
      freeDoubleArray(testbb,ix);
      freeDoubleArray(testbb_rot,iy);
//      if (testbb != NULL) free(testbb);
//      if (testbb_rot != NULL) free(testbb_rot);
      return;		
    }
		
    if(bytesPerPixel == 2)
    {
      bb16 = (u_short *)dimage.frameBuffer;
      u_short **testbb = getDoubleUShortArray(ix,iy);
      u_short **testbb_rot = getDoubleUShortArray(iy,ix);
      if(effectiveBitsPerPixel < 16)
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb16[i];
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) << (16-effectiveBitsPerPixel);
          testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) >> (16-effectiveBitsPerPixel);				
        }		
      }
      else
      {
        for(i=0; i < n; i++)		
        {
          testbb[i/iy][i%iy] = bb16[i];
        }		
      }		
      for(i=0; i < ix; i++)
      {
        for(j=0; j < iy; j++)			
        {
          testbb_rot[j][i] = testbb[i][j];
        }		
      }		
      dims[0] = ix;		
      dims[1] = iy;
      ndim = 2;
      lsp[0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
      lp = (double *) mxGetPr(lsp[0]);	

      for(i=0; i < n; i++)
      {
        lp[i] = ((double)(testbb_rot[i/ix][i%ix]))*koef;			
      }
      infofuncionVSV3(dimage, lsp[1]);				
      if (ret == 0) lsp[2] = mxCreateString ("");
      freeDoubleUShortArray(testbb,ix);
      freeDoubleUShortArray(testbb_rot,iy);
      //if (testbb != NULL) free(testbb);
      //if (testbb_rot != NULL) free(testbb_rot);
      return;	
    }
	 	
    if(bytesPerPixel == 3)
    {
      if(imageFormat == 1)  //RGB
      {				
        BYTE **testbb = getDoubleByteArray(ix,iy);;
        BYTE **testbb_rot = getDoubleByteArray(iy,ix);
        bb = (BYTE*)(dimage.frameBuffer);		
        dims[0] = ix;
        dims[1] = iy;
        dims[2] = 3;		
        ndim = 3;
        lsp [0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
        lp = (double *) mxGetPr (lsp [0]);			
        for(int k=0; k<3; k++)
        {
          for(i=0; i < n; i++)		
          {
            testbb[i/iy][i%iy] = bb[3*i+k];
          }			

          for(i=0; i < ix; i++)
          {
            for(j=0; j < iy; j++)			
            {
              testbb_rot[j][i] = testbb[i][j];
            }		
          }			
          for(i=0; i < n; i++)
          {
            *lp++ = ((double)(testbb_rot[i/ix][i%ix]))/255.0;			
          }			
        }
        infofuncionVSV3(dimage, lsp[1]);				
        if (ret == 0) lsp[2] = mxCreateString ("");	
        freeDoubleArray(testbb,ix);
        freeDoubleArray(testbb_rot,iy);
        //if (testbb != NULL) free(testbb);
        //if (testbb_rot != NULL) free(testbb_rot);
        return;			
      }
			
			if(imageFormat == 5)  //JPEG24
			{
				int rWidth;
				int rHeight;
				int rFmt; // 0 == gray8, 1== RGB24
				BYTE *tmpBuffer=NULL;

				tmpBuffer = new BYTE[dimage.frameHeader.appendedFrameSize];
				if (tmpBuffer == NULL) return;

				memcpy(tmpBuffer, dimage.frameBuffer, dimage.frameHeader.appendedFrameSize);

        bool bret = internalDecompressJPEG(tmpBuffer, dimage.frameHeader.appendedFrameSize, 
                      dimage.frameBuffer, dimage.frameBufferSize, rWidth, rHeight, rFmt);

				if (bret == true)
				{
					dimage.frameHeader.sourceFormat = CF_IMAGE_FORMAT_JPEG;

					dimage.frameHeader.imageFormat = CF_IMAGE_FORMAT_GRAY;
					dimage.frameHeader.bytesPerPixel = 1;
					dimage.frameHeader.effectiveBitsPerPixel = 8;

					if (rFmt == 1) // RGB24
					{
						dimage.frameHeader.imageFormat = CF_IMAGE_FORMAT_RGB;
						dimage.frameHeader.bytesPerPixel = 3;
						dimage.frameHeader.effectiveBitsPerPixel = 24;
					}

					dimage.frameHeader.appendedFrameSize = rWidth * rHeight * 
																	dimage.frameHeader.bytesPerPixel;
					// no aoi
					dimage.frameHeader.sourceWidth = rWidth;
					dimage.frameHeader.sourceHeight = rHeight;
					dimage.frameHeader.xStart = 0;
					dimage.frameHeader.yStart = 0;

					dimage.frameHeader.aoiWidth = -1;
					dimage.frameHeader.aoiHeight = -1;
				}
				else
				{
					memcpy(dimage.frameBuffer, tmpBuffer, dimage.frameHeader.appendedFrameSize);
				}

				if (tmpBuffer != NULL)
				{
					delete [] tmpBuffer;
					tmpBuffer = NULL;
				}

				bb = (BYTE*)(dimage.frameBuffer);		
        BYTE **testbb = getDoubleByteArray(ix,iy);;
        BYTE **testbb_rot = getDoubleByteArray(iy,ix);
				dims[0] = ix;
				dims[1] = iy;
				dims[2] = 3;		
				ndim = 3;
				lsp [0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
				lp = (double *) mxGetPr (lsp [0]);			
				for(int k=0; k<3; k++)
				{
					for(i=0; i < n; i++)		
					{
						testbb[i/iy][i%iy] = bb[3*i+k];
					}			

					for(i=0; i < ix; i++)
					{
						for(j=0; j < iy; j++)			
						{
							testbb_rot[j][i] = testbb[i][j];
						}		
					}			
					for(i=0; i < n; i++)
					{
						*lp++ = ((double)(testbb_rot[i/ix][i%ix]))/255.0;			
					}			
				}
				infofuncionVSV3(dimage, lsp[1]);				
				if (ret == 0) lsp[2] = mxCreateString ("");
        freeDoubleArray(testbb,ix);
        freeDoubleArray(testbb_rot,iy);
        //if (testbb != NULL) free(testbb);
        //if (testbb_rot != NULL) free(testbb_rot);
				return ;			
			}				
		}
	
		if(bytesPerPixel == 4)
		{
			bb32 = (u_int *)dimage.frameBuffer;
      u_int **testbb = getDoubleUintArray(ix,iy);
      u_int **testbb_rot = getDoubleUintArray(iy,ix);
			if(effectiveBitsPerPixel < 32)
			{
				for(i=0; i < n; i++)		
				{
					testbb[i/iy][i%iy] = bb32[i];
					testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) << (32-effectiveBitsPerPixel);
					testbb[i/iy][i%iy] = (testbb[i/iy][i%iy]) >> (32-effectiveBitsPerPixel);				
				}		
			}
			else
			{
				for(i=0; i < n; i++)		
				{
					testbb[i/iy][i%iy] = bb32[i];
				}		
			}		
			for(i=0; i < ix; i++)
			{
				for(j=0; j < iy; j++)			
				{
					testbb_rot[j][i] = testbb[i][j];
				}		
			}		
			dims[0] = ix;		
			dims[1] = iy;
			ndim = 2;
			lsp[0] =  mxCreateNumericArray(ndim, dims,  mxDOUBLE_CLASS,mxREAL);
			lp = (double *) mxGetPr(lsp[0]);	

			for(i=0; i < n; i++)
			{
				lp[i] = ((double)(testbb_rot[i/ix][i%ix]))*koef;			
			}
			infofuncionVSV3(dimage, lsp[1]);				
			if (ret == 0) lsp[2] = mxCreateString ("");
      freeDoubleUintArray(testbb,ix);
      freeDoubleUintArray(testbb_rot,iy);
      //if (testbb != NULL) free(testbb);
      //if (testbb_rot != NULL) free(testbb_rot);
			return;	
		}		
				
	}

err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
	return;	
}

/*
mex -DLINUX -D_REENTRANT  -I/products/matlab/amd64_rhel50/v7.5/extern/include -I/doocs/develop/anushh/amd64_rhel50/lib/include -I/usr/include -L/doocs/develop/anushh/amd64_rhel50/lib -lDOOCSapi -L/usr/lib64 -ljpeg -L/products/matlab/amd64_rhel50/v7.5/bin/glnxa64 -lmx -lmat getTimage.cc
*/
 
