#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

char *Buffer = NULL;
int mlBufferSize = MAX_TINE_BUFFER;
#define usageStr "tine_servers usage:\n ret=tine_servers('<context>');\n'ret' contains the status/error message and returned names"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray	*data[PROPMAX];
  const char *field[PROPMAX];
  double *lp, dt = (double)time(NULL);
  int	error[PROPMAX];
  char *name, *subsys=NULL, *typestr, *mxerrStr=NULL;
  char *p;
  char buf[1024];
  char bf1[1024], *c=NULL, *c1=NULL, *c2=NULL, *c3=NULL;
  char dtstr[32];
  char prop[80];
  char dev[80];
  int	len,type,size,fmtsiz,readsize = -1,ln,datatype = -1;
  int	dims[2];
  int	i,j,k,err,count = 0,n,startindex = 3;
  int	lim,nmb;
  int acc = CA_READ;
  mxChar *CharData;
  char tsstr[64];
  char *tmpBuffer;
  NAME32 *slist;
  PrpQueryStruct *pqsLst;
  int nsrvs;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 2: 
      mxerr(usageStr);
      if (!mxIsChar(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[1]) + 1;
      subsys = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[1],subsys,len);
    case 1: // target
      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      // the requested data endpoint ...
      len = mxGetN(prhs[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],name,len);
      break;
    default:
      mxerr(usageStr);
  }   
  if (Buffer == NULL)
  {
    if ((Buffer=(char *)malloc(MAX_TINE_BUFFER)) == NULL)
    {
      plhs[0] = mxCreateString("Out of memory !!!");
      return;
    }
    mlBufferSize = MAX_TINE_BUFFER;
  }

  slist = (NAME32 *)Buffer;
  nsrvs = MAX_TINE_BUFFER/32;
  err = GetSystemServers(name,slist,&nsrvs);
  if (err != 0)
  {
    field[0] = (char *)mxCalloc(6, sizeof(char));
    strcpy((char *)field[0],"error");
    GetLastLinkError(-err,Buffer);
    plhs[0] = mxCreateStructMatrix(1, 1, 1, &field[0]);
    sprintf(buf,"Names read error: %s",Buffer);
    data[0] = mxCreateString(buf);
    mxSetFieldByNumber(plhs[0], 0, 0, data[0]);
  }
  else
  {
    size = nsrvs;
    for (n=0; n<nsrvs; n++)
    {
      field[n] = (char *)mxCalloc(32, sizeof(char));
      data[n] = mxCreateString(slist[n].name);
      strncpy((char *)field[n],slist[n].name,32);
    }
    plhs[0] = mxCreateStructMatrix(1,1,nsrvs,&field[0]);
    for (n=0; n<nsrvs; n++)
    {
      mxSetFieldByNumber(plhs[0],0,n,data[n]);
    }

 	}
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
  mxFree(name);
}
