#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 10
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

char Buffer[MAX_TINE_BUFFER];
#define usageStr "tine_dispatch usage:\n ret=tine_dispatch('<property>'[,<completion code>)"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray	*data[PROPMAX];
  const char *field[PROPMAX];
  char *prp=NULL, *dev=NULL,*mxerrStr=NULL,*fldStr,*fcn=NULL;
  double *lp;
  char buf[128],stsbuf[64],fmtOut[64];
  int	i,siz=0,len,fmt,err,n,cc=not_posted;
  int sizout=1;
  int ndevs=0,isScheduled=FALSE;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 2: // desired completion code
      if (!mxIsDouble(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      cc = (int)mxGetScalar(prhs[1]);
    case 1: // handler property
      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[0]) + 1;
      prp = (char *)mxCalloc(len, sizeof(char));
      break;
    default:
      mxerr(usageStr);
  }   

  err = SetBufferedPropertyCompletion(prp,cc);

  if (err != 0)
  {
    GetLastLinkError(err,stsbuf);
    sprintf(buf,"tine_dispatch : <%d> %.64s",err,stsbuf);
    mexErrMsgTxt(buf);
  }
  data[0] = mxCreateDoubleMatrix(1,1,mxREAL);
  lp = (double *)mxGetPr(data[0]);
  *lp = (double)err;
  plhs[0] = data[0];
  
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
  if (prp != NULL) mxFree(prp);
}
