/*
 * tine_evencomment.cpp : 
 */

#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"
#include "eventtools.h"

#define mxerr(s) { mxerrStr = (char *)s; goto err; }
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) 
{
  char *parameter1=NULL, *cmt, *mxerrStr=NULL;
  char *ctx=NULL,*trg=NULL;
  mxArray *temp;
  double *ptr;
  int buflen, status;
  char str[128],evnstr[64];
  int i, ndevices, evn, cc;

  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 2:
      mxGetString(prhs[1],evnstr,64);
      evn = (int)strtol(evnstr,NULL,0);
      if (mxGetM(prhs[0]) != 1) mxerr("Input must be a row vector.");
      ndevices = mxGetM(prhs[1]); // num requested devices (consistency check: property must be the same !)
      if (ndevices != 1) mxerr("multiple calls not supported at this time!");
      break;
    default:
      mxerr("tine_eventcomment usage:\ntine_evencomment('/<context>/<trigger>','<event_number>')\n");
  }
  if (nlhs > 1) mxerr("Too many output arguments");

  buflen = mxGetM(prhs[0])*mxGetN(prhs[0]) + 1;
  parameter1 = (char *) mxCalloc(buflen, sizeof(char));
  status = mxGetString(prhs[0], parameter1, buflen);
  if(status != 0) mexWarnMsgTxt("Not enough space. String is truncated.");
  // parse out the event server context and the event trigger
  if ((ctx=strtok(parameter1,"/")) == NULL) mxerr("1st argument not in the form: /<context>/<trigger>");
  if ((trg=strtok(NULL,"/")) == NULL) mxerr("1st argument not in the form: /<context>/<trigger>");

  for (i=0; i<ndevices; i++)
  { 
    if ((cmt=GetArchiveComment(ctx,trg,evn)) == NULL) cmt = "no comment";
    temp = mxCreateString(cmt);
  }
  plhs[0] = temp; 

err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
  if (parameter1 != NULL) mxFree(parameter1); 
}