#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 10
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

#define getDblVal(i,b,f) (\
  (double)((f) == CF_BYTE ? (b)[i] :\
           (f) == CF_INT16 ? ((short *)(b))[i] :\
           (f) == CF_INT32 ? ((int *)(b))[i] :\
           (f) == CF_INT64 ? ((SINT64 *)(b))[i] :\
           (f) == CF_FLOAT ? ((float *)(b))[i] :\
           (f) == CF_DOUBLE ? ((double *)(b))[i] : 0))

#define get1stDblVal(i,b,f) (\
  (double)((f) == CF_INTINT ? ((INTINT *)(b))[i].i1val :\
           (f) == CF_FLTINT ? ((FLTINT *)(b))[i].fval :\
           (f) == CF_DBLDBL ? ((DBLDBL *)(b))[i].d1val :\
           (f) == CF_FLTFLT ? ((FLTFLT *)(b))[i].f1val : 0))

#define get2ndDblVal(i,b,f) (\
  (double)((f) == CF_INTINT ? ((INTINT *)(b))[i].i2val :\
           (f) == CF_FLTINT ? ((FLTINT *)(b))[i].ival :\
           (f) == CF_DBLDBL ? ((DBLDBL *)(b))[i].d2val :\
           (f) == CF_FLTFLT ? ((FLTFLT *)(b))[i].f2val : 0))

#define get1stQuadVal(i,b,f) (\
  (double)((f) == CF_INTINTINTINT ? ((DADDRESS *)(b))[i].i1val :\
           (f) == CF_INTFLTFLTFLT ? ((DFILTER *)(b))[i].ival :\
           (f) == CF_INTINTFLTFLT ? ((FWINDOW *)(b))[i].i1val :\
           (f) == CF_TTII         ? ((DWINDOW *)(b))[i].t1 :\
           (f) == CF_FLTINTFLTINT ? ((FLTINTFLTINT *)(b))[i].f1val : 0))

#define get2ndQuadVal(i,b,f) (\
  (double)((f) == CF_INTINTINTINT ? ((DADDRESS *)(b))[i].i2val :\
           (f) == CF_INTFLTFLTFLT ? ((DFILTER *)(b))[i].f1val :\
           (f) == CF_INTINTFLTFLT ? ((FWINDOW *)(b))[i].i2val :\
           (f) == CF_TTII         ? ((DWINDOW *)(b))[i].t2 :\
           (f) == CF_FLTINTFLTINT ? ((FLTINTFLTINT *)(b))[i].i1val : 0))

#define get3rdQuadVal(i,b,f) (\
  (double)((f) == CF_INTINTINTINT ? ((DADDRESS *)(b))[i].i3val :\
           (f) == CF_INTFLTFLTFLT ? ((DFILTER *)(b))[i].f2val :\
           (f) == CF_INTINTFLTFLT ? ((FWINDOW *)(b))[i].f1val :\
           (f) == CF_TTII         ? ((DWINDOW *)(b))[i].i1val :\
           (f) == CF_FLTINTFLTINT ? ((FLTINTFLTINT *)(b))[i].f2val : 0))

#define get4thQuadVal(i,b,f) (\
  (double)((f) == CF_INTINTINTINT ? ((DADDRESS *)(b))[i].i4val :\
           (f) == CF_INTFLTFLTFLT ? ((DFILTER *)(b))[i].f3val :\
           (f) == CF_INTINTFLTFLT ? ((FWINDOW *)(b))[i].f2val :\
           (f) == CF_TTII         ? ((DWINDOW *)(b))[i].i2val :\
           (f) == CF_FLTINTFLTINT ? ((FLTINTFLTINT *)(b))[i].i2val : 0))

#define get1stTriVal(i,b,f) (\
  (double)((f) == CF_INTINTINT ? ((INTINTINT *)(b))[i].i1val :\
           (f) == CF_FLTFLTINT ? ((FLTFLTINT *)(b))[i].f1val :\
           (f) == CF_INTFLTINT ? ((INTFLTINT *)(b))[i].i1val :\
           (f) == CF_FLTINTINT ? ((FLTINTINT *)(b))[i].fval :\
           (f) == CF_DBLDBLDBL ? ((DBLDBLDBL *)(b))[i].d1val : 0))

#define get2ndTriVal(i,b,f) (\
  (double)((f) == CF_INTINTINT ? ((INTINTINT *)(b))[i].i2val :\
           (f) == CF_FLTFLTINT ? ((FLTFLTINT *)(b))[i].f2val :\
           (f) == CF_INTFLTINT ? ((INTFLTINT *)(b))[i].fval :\
           (f) == CF_FLTINTINT ? ((FLTINTINT *)(b))[i].i1val :\
           (f) == CF_DBLDBLDBL ? ((DBLDBLDBL *)(b))[i].d2val : 0))

#define get3rdTriVal(i,b,f) (\
  (double)((f) == CF_INTINTINT ? ((INTINTINT *)(b))[i].i3val :\
           (f) == CF_FLTFLTINT ? ((FLTFLTINT *)(b))[i].ival :\
           (f) == CF_INTFLTINT ? ((INTFLTINT *)(b))[i].i2val :\
           (f) == CF_FLTINTINT ? ((FLTINTINT *)(b))[i].i2val :\
           (f) == CF_DBLDBLDBL ? ((DBLDBLDBL *)(b))[i].d3val : 0))

char Buffer[MAX_TINE_BUFFER];
#define usageStr "tine_pulldata usage:\n ret=tine_pulldata('<property>','<device>',size)"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray	*data[PROPMAX];
  const char *field[PROPMAX];
  char prp[PROPERTY_NAME_SIZE], dev[DEVICE_NAME_SIZE], *mxerrStr=NULL;
  double *lp;
  char buf[128],stsbuf[64],fmtIn[64];
  int	i,k,siz=0,len,fmt,fmtsiz,err,n;
  mwSize dims[2];
  int sizin=0;
  int ndevs=0,isScheduled=FALSE;
  mxChar *mxc;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 3:
      if (!mxIsDouble(prhs[2])) mxerr(usageStr);
      if (mxGetM(prhs[2]) != 1) mxerr(usageStr);
      siz = (int)mxGetScalar(prhs[2]);
      if (!mxIsChar(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[1]) + 1;
      //dev = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[1],dev,len);

      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[0]) + 1;
      //prp = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],prp,len);

      err = GetRegisteredPropertyInformation(NULL,prp,NULL,NULL,NULL,
              NULL,&sizin,NULL,fmtIn,NULL);
      if (err != 0) goto inpt_err;
      if (siz == 0) siz = sizin;
      fmt = GetFormatFromString(fmtIn);
      break;
    default:
      mxerr(usageStr);
  }   
  if (siz < 1) mxerr("invalid data size given");
  err = pullBufferedData(prp,dev,(BYTE *)Buffer,siz);

  fmtsiz = fmtsizeof(fmt);
  switch (fmt)
  {
    case CF_TEXT: 
      data[0] = mxCreateString(Buffer);
      break;
    case CF_NAME8:
    case CF_NAME16:
    case CF_NAME32:
    case CF_NAME48:
    case CF_NAME64:
      dims[0] = siz;
      dims[1] = fmtsiz;
      if (siz > 1)
      {
        data[0] = mxCreateCharArray(2,dims);
        mxc = (mxChar *)mxGetData(data[0]);
        for (i=0; i<siz; i++)
        { /* string arrays transposed in MatLab ? */
          for (k=0; k<fmtsiz; k++) mxc[siz*k+i] = (mxChar)Buffer[fmtsiz*i+k];
        }
      }
      else
      {
        data[0] = mxCreateString(Buffer);
      }
      break;
    case CF_BYTE:
    case CF_INT16:
    case CF_INT32:
    case CF_INT64:
    case CF_FLOAT:
    case CF_DOUBLE:
      data[0] = mxCreateDoubleMatrix(siz,1,mxREAL);
      lp = (double *)mxGetPr(data[0]);
      for (i=0; i<siz; i++) *lp++ = getDblVal(i,(BYTE *)Buffer,fmt);
      break;
    case CF_INTINT:
    case CF_FLTINT:
    case CF_FLTFLT:
    case CF_DBLDBL:
      data[0] = mxCreateDoubleMatrix(siz,2,mxREAL);
      lp = (double *)mxGetPr(data[0]);
      for (i=0; i<siz; i++) 
      {
        *lp       = get1stDblVal(i,(BYTE *)Buffer,fmt);
        *(lp+siz) = get2ndDblVal(i,(BYTE *)Buffer,fmt);
        lp++;
      }
      break;
    case CF_INTINTINT:
    case CF_DBLDBLDBL:
    case CF_FLTFLTINT:
    case CF_INTFLTINT:
    case CF_FLTINTINT:
      data[0] = mxCreateDoubleMatrix(siz,3,mxREAL),
      lp = (double *)mxGetPr(data[0]);
      for (i=0; i<siz; i++) 
      {
        *lp         = get1stTriVal(i,(BYTE *)Buffer,fmt);
        *(lp + siz) = get2ndTriVal(i,(BYTE *)Buffer,fmt);
        *(lp+2*siz) = get3rdTriVal(i,(BYTE *)Buffer,fmt);
        lp++;
      }
      break;
    case CF_IFFF:
    case CF_FIFI:
    case CF_IIII:
    case CF_IIFF:
    case CF_TTII:
      data[0] = mxCreateDoubleMatrix(siz,4,mxREAL),
      lp = (double *)mxGetPr(data[0]);
      for (i=0; i<siz; i++) 
      {
        *lp         = get1stQuadVal(i,(BYTE *)Buffer,fmt);
        *(lp + siz) = get2ndQuadVal(i,(BYTE *)Buffer,fmt);
        *(lp+2*siz) = get3rdQuadVal(i,(BYTE *)Buffer,fmt);
        *(lp+3*siz) = get4thQuadVal(i,(BYTE *)Buffer,fmt);
        lp++;
      }
      break;
    default:
      err = illegal_format; 
      data[0] = mxCreateString("oops!");
      goto inpt_err; 
  }

inpt_err:
  if (err != 0)
  {
    GetLastLinkError(err,stsbuf);
    sprintf(buf,"tine_pulldata : <%d> %.64s",err,stsbuf);
    mexErrMsgTxt(buf);
  }
  plhs[0] = data[0];
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
}
