#include <math.h>
#include "mex.h"
#include "tine.h"
#include "tbufsrv.h"

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#define mxerr(s) { mxerrStr = (char *)s; goto err; }

char *Buffer = NULL;
int mlBufferSize = MAX_TINE_BUFFER;
#define usageStr "tine_properties usage:\n ret=tine_properties('/<context>/<server>/<device>'[,timeout]);\n'ret' contains the status/error message and returned names"
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
  mxArray  *data[PROPMAX];
  const char *field[PROPMAX];
  double *lp, dt = (double)time(NULL);
  int  error[PROPMAX];
  char *name, *typestr, *mxerrStr=NULL;
  char *p;
  char buf[1024];
  char bf1[1024], *c=NULL, *c1=NULL, *c2=NULL, *c3=NULL;
  char dtstr[32];
  char prop[80];
  char dev[80];
  int  len,type,size,fmtsiz,readsize = -1,ln,datatype = -1;
  mwSize dims[2];
  int  i,j,k,err,count = 0,n,startindex = 3;
  int  lim,nmb;
  int tmr = 1000;
  int acc = CA_READ;
  mxChar *CharData;
  char tsstr[64];
  char *tmpBuffer;
  NAME64 *plist;
  PrpQueryStruct *pqsLst;
  int nprps;
    
  if (plhs == NULL || prhs == NULL) return;
  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 2: // timer interval (int)
      if (!mxIsDouble(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      tmr = (int)mxGetScalar(prhs[1]);
    case 1: // target
      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      // the requested data endpoint ...
      len = mxGetN(prhs[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],name,len);
      break;
    default:
      mxerr(usageStr);
  }   
  if (Buffer == NULL)
  {
    if ((Buffer=(char *)malloc(MAX_TINE_BUFFER)) == NULL)
    {
      plhs[0] = mxCreateString("Out of memory !!!");
      return;
    }
    mlBufferSize = MAX_TINE_BUFFER;
  }

//  plist = (NAME64 *)Buffer;
//  nprps = MAX_TINE_BUFFER/64;
//  err = GetSystemProperties(name,plist,&nprps);
  pqsLst = (PrpQueryStruct *)Buffer;
  nprps = MAX_TINE_BUFFER/sizeof(PrpQueryStruct);
  err = GetSystemPropertyInformation(name,NULL,&pqsLst,&nprps);
  if (err < 0)
  {
    GetLastLinkError(-err,Buffer);
    plhs[0] = mxCreateStructMatrix(1, 1, 1, &field[0]);
    sprintf(buf,"Names read error: %s",Buffer);
    data[0] = mxCreateString(buf);
    mxSetFieldByNumber(plhs[0], 0, 0, data[0]);
  }
  else
  {
    size = nprps;
    for (n=0; n<nprps; n++)
    {
      field[n] = (char *)mxCalloc(72, sizeof(char));
//      data[n] = mxCreateString(plist[n].name);
//      strncpy((char *)field[n],plist[n].name,64);
      data[n] = mxCreateString(pqsLst[n].prpDescription);
      strncpy((char *)field[n],pqsLst[n].prpName,64);
    }
    plhs[0] = mxCreateStructMatrix(1,1,nprps,&field[0]);
    for (n=0; n<nprps; n++)
    {
      mxSetFieldByNumber(plhs[0],0,n,data[n]);
    }

 	}
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
  mxFree(name);
}
